*++
* File BIO.FOR
*
* Created: 17-Feb-90 by J.Huber
* Changed: 8-Oct-1997 J.Huber
*          from BIO to BIO2: the RAB arguments are changed to LUN arguments
*          since FOR$RAB is a Vested library routine (forrtl_*_TV), and requres
*          to be linked /NONATIVE
*          The RAB used on LUN is saved in a common, up to a maximum LUN
*
* <title> Collection of simple RMS-Block-I/O routines </title>
* This allows sequential read/write of arbitrary length blocks starting
* at a (512-byte-) block boundary.
* The file has to be opened in the main program by an open statement like
* this:
*	External BIO_OPEN
*	Open(unit=lun,name=fn,
*	1 iostat=iostat,status='OLD',READONLY,
*       2 access='DIRECT',recordtype='FIXED',
*       3 organization='SEQUENTIAL',recl=128,
*	4 useropen=BIO_OPEN)
*         useropen=BIO_OPENW if NOT READONLY
*
*	Then blocks can be read (written) by calls like
*
*	Integer BIO_READ,BIO_WRITE
*	iostat = BIO_READ(%val(FOR$RAB(lun)),Buffer,NB)
*	or
*	iostat = BIO_WRITE(%val(FOR$RAB(lun)),Buffer,NB)
*	If (iostat) Then
*	 ...
*	Else
*	 !I/O error 
*	 !RMS$_EOF status code indicates normal end-of-file
*	EndIf
*--

*
* BIO_OPEN - user-open routine to open a file for block i/o - existing files
*
	Integer Function BIO_OPEN(FAB,RAB,LUN)
        IMPLICIT NONE
	Integer LUN
	Include '($FABDEF)'
	Include '($RABDEF)'
	Include '($SYSSRVNAM)'

* declare FAB and RAB blocks
	Record /FABDEF/ FAB, /RABDEF/ RAB
	INTEGER BIO_OPENW,BIO_CLOSE

        include 'RABADR.INC'

100     CONTINUE
        if (LUN .le. MAXLUN) then
         RABADR(LUN) = %LOC(RAB)
         FABADR(LUN) = %LOC(FAB)
        endif

*	Fortran open leaves FAB$B_FAC = 0 if opened with READONLY key.
*	Set the M_GET bit in this case to enable read:
	FAB.FAB$B_FAC = FAB.FAB$B_FAC .or. FAB$M_GET
*	set the block i/o bit in the FAC
	FAB.FAB$B_FAC = FAB.FAB$B_FAC.or.FAB$M_BIO
	RAB.RAB$L_ROP = RAB.RAB$L_ROP.or.RAB$M_BIO
*	open and connect:
	BIO_OPEN = SYS$OPEN(FAB)
        IF (.NOT.BIO_OPEN) THEN
         IF ((FAB.FAB$L_FOP.AND.FAB$M_CIF).NE.0) THEN
          BIO_OPEN = SYS$CREATE(FAB)
         ENDIF
        ENDIF
        IF (BIO_OPEN) THEN
	 BIO_OPEN = SYS$CONNECT(RAB)
	ENDIF
        RETURN

	ENTRY BIO_OPENW(FAB,RAB,LUN)
	FAB.FAB$L_FOP = FAB.FAB$L_FOP.or.FAB$M_CIF.or.FAB$M_SUP
	FAB.FAB$L_FOP = FAB.FAB$L_FOP.or.FAB$M_TEF
	FAB.FAB$B_FAC=FAB.FAB$B_FAC.or.FAB$M_PUT.OR.FAB$M_GET.OR.FAB$M_UPD
*	INITIAL VBN
	RAB.RAB$L_BKT = 1
        GOTO 100

	ENTRY BIO_CLOSE(FAB)
        BIO_CLOSE = SYS$CLOSE(FAB)
	End


	Integer Function BIO_READ(RAB,Buffer,NB)
*++
*	Integer Function BIO_READ(RAB,Buffer,NB)
* Read max NB bytes from next sequential 512-byte blocks into array Buffer 
* from the file connected with the record-access-block RAB.
* NB returns the number of bytes actually read.
* To pass the address of RAB, call it like this:
*	status = BIO_READ(%VAL(FOR$RAB(lun)),buffer,nb)
* Function return value: RMS service call (sys$read) completion code.
*--

	IMPLICIT NONE
	Include '($RMSDEF)'
	Include '($RABDEF)'
	Include '($SYSSRVNAM)'
	Byte Buffer(*)
	Integer NB
        Record /RABDEF/ RAB	
        INTEGER BIO_WRITE

	logical do_write

	do_write = .false.

*	specify number of bytes to read/write
	RAB.RAB$W_USZ = NB
*	pass buffer address
	RAB.RAB$L_UBF = %LOC(Buffer)

2	Continue

	RAB.RAB$L_ROP = RAB.RAB$L_ROP .or. RAB$M_BIO
	If (do_write) Then
	 BIO_READ = SYS$WRITE(RAB)
	Else
	 BIO_READ = SYS$READ(RAB)
	EndIf
*	RAB.RAB$W_RSZ    !sys$read returns length here
*	RAB.RAB$L_STS	!completion code returned
*	RAB.RAB$L_STV	!completion status value returned
	IF (DO_WRITE) THEN
	 NB = RAB.RAB$W_RSZ	!bytes read/written
	 RAB.RAB$L_BKT = RAB.RAB$L_BKT + (NB+511)/512	!update VBN
        ELSE
	 NB = RAB.RAB$W_STV0	!bytes read/written
	 NB = RAB.RAB$W_RSZ	!bytes read/written
        ENDIF
D	TYPE * ,' AFTER READ/WRITE STATUS:',RAB.RAB$L_STS,RAB.RAB$L_STV
D	TYPE * ,' AFTER READ/WRITE RAB$L_BKT:',RAB.RAB$L_BKT
	Return

	Entry BIO_WRITE(RAB,Buffer,NB)

*++
*	Entry BIO_WRITE(RAB,Buffer,NB)
* Write sequential 512-byte blocks from array Buffer into the file
* connected with the record-access-block RAB.
* NB = number of bytes to write
* NB on return contains the number of bytes actually written !
* to pass the address of RAB, call it like this:
*	status = BIO_WRITE(%VAL(FOR$RAB(lun)),buffer,nb)
* Function return value: RMS service call (sys$write) completion code.
*--
	do_write = .true.
*	BUFFER ADDRESS AND LENGTH
	RAB.RAB$W_RSZ = NB
	RAB.RAB$L_RBF = %LOC(Buffer)
	Go to 2

	End

	Integer Function BIO_REWIND(RAB)
*++
*	Integer Function BIO_REWIND(RAB)
* Rewinds the file connected with the record-access-block RAB.
* (i.e. resets the next-block field to point to block # 1).
* to pass the address of RAB, call it like this:
*	status = BIO_REWIND(%VAL(FOR$RAB(lun)))
* Function return value: RMS service call (sys$rewind) completion code.
*--

	Include '($RABDEF)'
	Include '($SYSSRVNAM)'
	Record /RABDEF/ RAB

	BIO_REWIND = SYS$REWIND(RAB)
*       If the file open for write: VBN must be set
	IF (RAB.RAB$L_BKT .NE.0) RAB.RAB$L_BKT = 1 
	Return
	End

	Integer Function BIO_SPACE(RAB,NB)
*++
*	Integer Function BIO_SPACE(RAB,NB)
* SPACEs the file connected with the record-access-block RAB NB blocks forward
* (NB>0) or backwards (NB<0).
* (i.e. the next sequential read/write starts at the new position).
* to pass the address of RAB, call it like this:
*	status = BIO_SPACE(%VAL(FOR$RAB(lun)),NB)
* Function return value: RMS service call (sys$SPACE) completion code.
*--

	Include '($RABDEF)'
	Include '($SYSSRVNAM)'
	Record /RABDEF/ RAB
	Integer NB

	RAB.RAB$L_BKT = NB	!pass number of blocks
	BIO_SPACE = SYS$SPACE(RAB)
*	correct VBN if the file is used for write
	IF (RAB.RAB$L_BKT .NE.0) RAB.RAB$L_BKT = RAB.RAB$L_BKT + nb
	Return
	End


