/* <title>  TCPIP socket connection </title>
 <META name="keywords" content="TCPIP,socket,connect,client,server">
 * $Id: tcpipc.h,v 2.1 2001/03/17 18:54:23 hoffmann Exp $
 *
 * buffer/tcpipb.h, Dirk Hoffmann, CPPM, March 2001
 *
 * Generation and management of the event buffers which are transmitted
 * through TCP/IP.
 * 
 */

#include <stdio.h>
#include <errno.h>
#include <string.h>
#ifdef VMS
#include <unixio.h>
#include <socket.h>
#include <netdb.h>
#include <in.h>
#else
#include <sys/types.h>
#include <netdb.h>
#include <netinet/in.h>
#include <socket.h>
#endif

#define SUCCESS          0	/* YOUPI */
#define ESOCK_CREATE	-2	/* socket creation failed*/
#define EBAD_NAME		-6	/* the machine name is false */
#define ESOCK_CONN		-7	/* socket connection failed*/

/*
 * client_connection(char *host, int port):
 *		Used by clients to connect themself to a server running on
 *		the host <host> with the port number <port>
 *		errors : EBAD_NAME or ESOCK_CREATE or ESOCK_CONN
 *		else	: sock descriptor
 */
int client_connection(char *host, int port)
{
struct	sockaddr_in adr; /* server address */
int		len,
		sock,lg,segmax;
struct	hostent  *hptr;
u_long	adresse;

	if((hptr=(struct hostent *)gethostbyname(host)) == NULL) {	
		perror("client_connection::gethostbyname");
 		return EBAD_NAME; }

	sock = socket(AF_INET,SOCK_STREAM,0);	/* client socket creation */
	if(sock == -1) {
		perror("client_connection::socket");
    	return ESOCK_CREATE; }

    memset( &adr, 0, sizeof(adr) );	/*build socket address */
	memcpy(&adr.sin_addr.s_addr, hptr->h_addr, hptr->h_length);
	adresse=ntohl( adr.sin_addr.s_addr);
	adr.sin_port=htons((u_short)port);/*cast for NT compatibilities */
	adr.sin_family = AF_INET;
	len=sizeof(adr);
	/*Making  connection */

	if( connect(sock,(struct sockaddr *) &adr,len) == -1) {	
		perror("client_connection::connect()");
 		return errno; }	

	return(sock);
}

