/* DECC$SHR_VERSION.C */

#include <stdio.h>
#include <dlfcn.h>
#include <stdlib.h>

extern int DECC$$GL___CRTL_VER;

int __crtl_ver_build=-1;
int __vms_ver_build=-1;
int __vms_min_version=-1;

void crtl_init_version()
{
    void *lib = dlopen("DECC$SHR", 0);
    void *ptr;

    if (!lib) {
	perror(">>> dlopen");
	exit(1);
    }
    else {
        ptr = dlsym(lib, "DECC$$GL___CRTL_VER_BUILD");
	if (!ptr)
	    __crtl_ver_build = DECC$$GL___CRTL_VER;
	else
	    __crtl_ver_build = *(int*)ptr;

	ptr = dlsym(lib, "DECC$$GL___VMS_VER_BUILD");
	if (!ptr)
	    __vms_ver_build = DECC$$GL___CRTL_VER;
	else
	    __vms_ver_build = *(int*)ptr;
    }

    __vms_min_version = (__vms_ver_build < __VMS_VER) ? __vms_ver_build : __VMS_VER;

    dlclose(lib);
}

int get_crtl_ver_build()
{
  if (__crtl_ver_build < 0)
    crtl_init_version();

  return __crtl_ver_build;
}



#ifdef MAIN
void main()
{
    crtl_init_version();

    printf("  __CRTL_VER = %d\n", __CRTL_VER);
    printf("  __VMS_VER = %d\n", __VMS_VER);
    printf("  DECC$$GL___CRTL_VER = %d\n", DECC$$GL___CRTL_VER);
    if (__crtl_ver_build != DECC$$GL___CRTL_VER)
	printf("  DECC$$GL___CRTL_VER_BUILD = %d\n", __crtl_ver_build);
    if (__vms_ver_build != DECC$$GL___CRTL_VER)
	printf("  DECC$$GL___VMS_VER_BUILD = %d\n", __vms_ver_build);

    puts("------------------------------------------------------------------------");
    puts("\t             C RTL      C RTL   C Compiler");
    puts("\t            Features    Base      ");
    puts("");

    printf("\t__VMS_VER   %8d  %8d  %8lld\n", __vms_min_version, __vms_ver_build, __VMS_VER);
    printf("\t__CRTL_VER  %8d  %8d  %8lld\n", __crtl_ver_build, DECC$$GL___CRTL_VER, __CRTL_VER);

    puts("");
    puts("------------------------------------------------------------------------");
    puts("  C RTL Features");
    puts("     __VMS_VER    The lowest value of the other 2 values of __VMS_VER");
    puts("     __CRTL_VER   The maximum feature level of this C RTL");
    puts("");
    puts("  C RTL Base");
    puts("     __VMS_VER    OpenVMS version for which this C RTL was built");
    puts("     __CRTL_VER   The minimum feature level of this C RTL");
    puts("");
    puts("  C Compiler");
    puts("     __VMS_VER    Usually the OpenVMS version of the running system");
    puts("     __CRTL_VER   Value used to evaluate expressions in C RTL headers");
    puts("------------------------------------------------------------------------");
    puts("");
}
#endif
















