\!++
!     Define symbols according to macro values
!--

.IFDEF DEBUG
DBG = /DEBUG
DBGOPT = /NOOPTIMIZE/DEBUG
.ELSE
DBG = /NODEBUG
DBGOPT = /OPTIMIZE/NODEBUG
.ENDIF

.IFDEF LIST
LST = /LIST
.ELSE
LST = /NOLIST
.ENDIF

.IFDEF DIAG
DIA = /DIAGNOSTICS
.ELSE
DIA = /NODIAGNOSTICS
.ENDIF

.IFDEF PCA
PCAOPT = /DEBUG
.ENDIF

.IFDEF SRC
SRCDIR = $(SRC)
.ELSE
SRCDIR = []
.ENDIF


.IFDEF INC
INCDIR = $(INC)
.ELSE
INCDIR = $(SRCDIR)
.ENDIF

.IFDEF __VAX__
TIE =
NATIVE =
FFLAGS =
.ELSE
TIE = /TIE
NATIVE = /NONATIVE
FFLAGS = /INCLUDE=($(INCDIR),[],[-.INCLUDE],SYS$LIBRARY:)
.ENDIF

CFLAGS = /INCLUDE=($(INCDIR),[],[-.INCLUDE],SYS$LIBRARY:)

.SUFFIXES : .exe .obj .c .h .for .f90 .f .inc .mar .cld .uil .uid

.c.obj :
        $(CC) $(CFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.for.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.f90.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.f.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.mar.obj :
        $(MACRO) $(LST) $(DBGOPT) $(DIA) $<

.cld.obj :
       SET COMMAND/OBJECT $<

.uil.uid :
       UIL $<

.obj.exe :
       LINK $(DBG) $(PCAOPT)  $<,$(LINKLIB)


.OBJ.OLB :
 @ IF F$SEARCH("$(MMS$TARGET)") .eqs. "" then -
 $(LIBR)/CREATE/LOG $(MMS$TARGET)
 $(LIBR) $(LIBRFLAGS) $(MMS$TARGET) $(MMS$SOURCE)

LINKLIB = SYS$LIBRARY:UTIL/LIB

OBJ1 =  BIGENDIAN=BIGENDIAN.OBJ,CLIENT_CONNECT=CLIENT_CONNECT.OBJ,-
CONVERT_ENDIANESS=CONVERT_ENDIANESS.OBJ,CVTNUM=CVTNUM.OBJ,-
ENDIANESS=ENDIANESS.OBJ,FS=FS.OBJ,GETBITS=GETBITS.OBJ,-
GET_ASCTIME=GET_ASCTIME.OBJ,INIT_CLI=INIT_CLI.OBJ,GETPAGESIZE=GETPAGESIZE.OBJ,- 
INIT_CLI_ARGV=INIT_CLI_ARGV.OBJ,INIT_CLI_FOR=INIT_CLI_FOR.OBJ,-
MAKE_DSC_STR=MAKE_DSC_STR.OBJ,MOVE_DATA=MOVE_DATA.OBJ,-
REMOVE_FILE_VERSION_C=REMOVE_FILE_VERSION_C.OBJ,SBYTE=SBYTE.OBJ,-
SPAWN_NOWAIT=SPAWN_NOWAIT.OBJ,STREAM_F=STREAM_F.OBJ,-
STREAM_FF=STREAM_FF.OBJ,SWORD=SWORD.OBJ,TIME_TO_TM=TIME_TO_TM.OBJ,
XTAPPMAINLOOP=XTAPPMAINLOOP.OBJ,SWAP_WORDS_C=SWAP_WORDS_C.OBJ

OBJ2 =  BROADCAST2REQID=BROADCAST2REQID.OBJ,BYTES_TO_CHAR=BYTES_TO_CHAR.OBJ,-
CLISPAWN=CLISPAWN.OBJ,CPUTIM=CPUTIM.OBJ,-
CRMPSC=CRMPSC.OBJ,CSLEEP=CSLEEP.OBJ,DATE4=DATE4.OBJ,DELAY=DELAY.OBJ,-
DCLEXH=DCLEXH.OBJ,FILE_SIZE=FILE_SIZE.OBJ,-
FILL_ITMLST=FILL_ITMLST.OBJ,FIND_FILE=FIND_FILE.OBJ,-
FIND_FILE_C=FIND_FILE_C.OBJ,FPARSE=FPARSE.OBJ,GBL_SECTION_UFO=GBL_SECTION_UFO.OBJ,-
GETCML=GETCML.OBJ,GETSYI_NODENAME=GETSYI_NODENAME.OBJ,-
GET_OPTION_VALUE=GET_OPTION_VALUE.OBJ,GET_TOKEN=GET_TOKEN.OBJ,-
GIVER4=GIVER4.OBJ,I2TOI4=I2TOI4.OBJ,ISHELL=ISHELL.OBJ,ISLEEP=ISLEEP.OBJ,-
ISORT=ISORT.OBJ,GETPRN=GETPRN.OBJ,HG$GET_INPUT=HG_GET_INPUT.OBJ

OBJ3 = JULIAN_DAY=JULIAN_DAY.OBJ,LENSTR=LENSTR.OBJ,LIMIT=LIMIT.OBJ,-
LOGSYSMESSAGE=LOGSYSMESSAGE.OBJ,MT$ASSIGN=MTUTIL.OBJ,-
OPMSG=OPMSG.OBJ,PADD_ZS=PADD_ZS.OBJ,PARSE_OS9_FILE=PARSE_OS9_FILE.OBJ,-
PARSE_OS9_FILE_C=PARSE_OS9_FILE_C.OBJ,PERMUT=PERMUT.OBJ,-
PRCPID=PRCPID.OBJ,PRINT_AND_DELETE=PRINT_AND_DELETE.OBJ,-
PROCESS_SCAN=PROCESS_SCAN.OBJ,PUTMSG=PUTMSG.OBJ,REMOVE_FILE_VERSION=REMOVE_FILE_VERSION.OBJ,-
RESOURCE_LOCK_CREATE=RESOURCE_LOCK.OBJ,ROT=ROT.OBJ,ROTVC=ROTVC.OBJ,-
SEND_BROADCAST=SEND_BROADCAST.OBJ,SEND_MBX_MESSAGE=SEND_MBX_MESSAGE.OBJ,-
SPAWN_AND_READ=SPAWN_AND_READ.OBJ,STR$LOWER=STR_LOWER.OBJ,-
SWAP_B=SWAP_B.OBJ,SWAP_W=SWAP_W.OBJ,SWAP_WORDS_F=SWAP_WORDS_F.OBJ

OBJ4 = TAPUSE=TAPUSE.OBJ,TIMER_INIT=TIMER_INIT.OBJ,UNQUOTE=UNQUOTE.OBJ,-
USERNAME=USERNAME.OBJ,USROPN=USROPN.OBJ,VMS_GETPID=VMS_GETPID.OBJ,-
SHELL=SHELL.OBJ,POLAR=POLAR.OBJ,RECTAN=RECTAN.OBJ,I2BIT=I2BIT.OBJ,-
OPENFF=OPENFF.OBJ,STRLEN=STRLEN.OBJ

ALLOBJ = $(OBJ1),$(OBJ2),$(OBJ3),$(OBJ4)

!++
!   Complete application - default build item
!--

COMPLETE_APPLICATION depends_on UTIL.OLB
    CONTINUE
   
UTIL.OLB depends_on UTIL.OLB($(ALLOBJ))

    CONTINUE

INSTALL depends_on COMPLETE_APPLICATION
  IF f$search("UTIL.OLB").nes."" then -
backup/delete UTIL.OLB;0 SYS$COMMON:[SYSLIB]/NEW/LOG/PROT=W:R

    CONTINUE

BIO.OBJ depends_on  $(SRCDIR)BIO.FOR  $(INCDIR)RABADR.INC

MTUTIL.OBJ depends_on   $(SRCDIR)MTUTIL.FOR  $(INCDIR)MTSENSE.INC

FIND_FILE_C.OBJ depends_on  $(SRCDIR)FIND_FILE_C.FOR

GETCML.OBJ depends_on   $(SRCDIR)GETCML.FOR  $(INCDIR)GCML$CODES.INC

PARSE_OS9_FILE_C.OBJ depends_on   $(SRCDIR)PARSE_OS9_FILE_C.FOR

RESOURCE_LOCK..OBJ depends_on   $(SRCDIR)RESOURCE_LOCK.FOR  $(INCDIR)RESOURCE_CTX.INC

STREAM_F.OBJ  depends_on $(SRCDIR)STREAM_F.C  $(INCDIR)stream_f.h

STREAM_FF.OBJ depends_on $(SRCDIR)STREAM_FF.C $(INCDIR)stream_f.h

CLIENT_CONNECT.OBJ depends_on $(SRCDIR)CLIENT_CONNECT.C 

CONVERT_ENDIANESS.OBJ depends_on $(SRCDIR)CONVERT_ENDIANESS.C 

CVTNUM.OBJ depends_on $(SRCDIR)CVTNUM.C 

ENDIANESS.OBJ depends_on $(SRCDIR)ENDIANESS.C 

FS.OBJ depends_on $(SRCDIR)FS.C 

GETBITS.OBJ depends_on $(SRCDIR)GETBITS.C 

GET_ASCTIME.OBJ depends_on $(SRCDIR)GET_ASCTIME.C 

IEEE2VAXF.OBJ depends_on $(SRCDIR)IEEE2VAXF.C 

INIT_CLI.OBJ depends_on $(SRCDIR)INIT_CLI.C 

INIT_CLI_ARGV.OBJ depends_on $(SRCDIR)INIT_CLI_ARGV.C 

MAKE_DSC_STR.OBJ depends_on $(SRCDIR)MAKE_DSC_STR.C 

MOVE_DATA.OBJ depends_on $(SRCDIR)MOVE_DATA.C 

REMOVE_FILE_VERSION_C.OBJ depends_on $(SRCDIR)REMOVE_FILE_VERSION_C.C 

SBYTE.OBJ depends_on $(SRCDIR)SBYTE.C 

SPAWN_NOWAIT.OBJ depends_on $(SRCDIR)SPAWN_NOWAIT.C 

STREAM_F.OBJ depends_on $(SRCDIR)STREAM_F.C

STREAM_FF.OBJ depends_on $(SRCDIR)STREAM_FF.C

SWORD.OBJ depends_on $(SRCDIR)SWORD.C 

TIME_TO_TM.OBJ depends_on $(SRCDIR)TIME_TO_TM.C 

XTAPPMAINLOOP.OBJ depends_on $(SRCDIR)XTAPPMAINLOOP.C 

SWAP_WORDS_C.OBJ depends_on $(SRCDIR)SWAP_WORDS_C.C

BIGENDIAN.OBJ depends_on $(SRCDIR)BIGENDIAN.FOR

BROADCAST2REQID.OBJ depends_on $(SRCDIR)BROADCAST2REQID.FOR 

BYTES_TO_CHAR.OBJ depends_on $(SRCDIR)BYTES_TO_CHAR.FOR 

CLISPAWN.OBJ depends_on $(SRCDIR)CLISPAWN.FOR 

CPUTIM.OBJ depends_on $(SRCDIR)CPUTIM.FOR 

CRMPSC.OBJ depends_on $(SRCDIR)CRMPSC.FOR 

CSLEEP.OBJ depends_on $(SRCDIR)CSLEEP.FOR 

DATE4.OBJ depends_on $(SRCDIR)DATE4.FOR 

DELAY.OBJ depends_on $(SRCDIR)DELAY.FOR 

DCLEXH.OBJ depends_on $(SRCDIR)DCLEXH.FOR 

FILE_SIZE.OBJ depends_on $(SRCDIR)FILE_SIZE.FOR 

FILL_ITMLST.OBJ depends_on $(SRCDIR)FILL_ITMLST.FOR 

FIND_FILE.OBJ depends_on $(SRCDIR)FIND_FILE.FOR 

FIND_FILE_C.OBJ depends_on $(SRCDIR)FIND_FILE_C.FOR

FPARSE.OBJ depends_on $(SRCDIR)FPARSE.FOR 

GBL_SECTION_UFO.OBJ depends_on $(SRCDIR)GBL_SECTION_UFO.FOR 

GETCML.OBJ depends_on $(SRCDIR)GETCML.FOR

GETPRN.OBJ depends_on $(SRCDIR)GETPRN.FOR

GETSYI_NODENAME.OBJ depends_on $(SRCDIR)GETSYI_NODENAME.FOR 

GET_OPTION_VALUE.OBJ depends_on $(SRCDIR)GET_OPTION_VALUE.FOR 

GET_TOKEN.OBJ depends_on $(SRCDIR)GET_TOKEN.FOR 

GIVER4.OBJ depends_on $(SRCDIR)GIVER4.FOR 

HG_GET_INPUT.OBJ depends_on $(SRCDIR)HG$GET_INPUT.FOR
  Fortran $(SRCDIR)HG$GET_INPUT/OBJ=HG_GET_INPUT.OBJ

I2TOI4.OBJ depends_on $(SRCDIR)I2TOI4.FOR 

INIT_CLI_FOR.OBJ depends_on $(SRCDIR)INIT_CLI_FOR.FOR

ISLEEP.OBJ depends_on $(SRCDIR)ISLEEP.FOR 

ISORT.OBJ depends_on $(SRCDIR)ISORT.FOR 

GETPRN.OBJ depends_on $(SRCDIR)GETPRN.FOR 

JULIAN_DAY.OBJ depends_on $(SRCDIR)JULIAN_DAY.FOR 

LENSTR.OBJ depends_on $(SRCDIR)LENSTR.FOR 

LIMIT.OBJ depends_on $(SRCDIR)LIMIT.FOR 

LOGSYSMESSAGE.OBJ depends_on $(SRCDIR)LOGSYSMESSAGE.FOR 

OPMSG.OBJ depends_on $(SRCDIR)OPMSG.FOR 

PADD_ZS.OBJ depends_on $(SRCDIR)PADD_ZS.FOR 

PARSE_OS9_FILE.OBJ depends_on $(SRCDIR)PARSE_OS9_FILE.FOR 

PARSE_OS9_FILE_C.OBJ depends_on $(SRCDIR)PARSE_OS9_FILE_C.FOR

PERMUT.OBJ depends_on $(SRCDIR)PERMUT.FOR 

PRCPID.OBJ depends_on $(SRCDIR)PRCPID.FOR

PRINT_AND_DELETE.OBJ depends_on $(SRCDIR)PRINT_AND_DELETE.FOR 

PROCESS_SCAN.OBJ depends_on $(SRCDIR)PROCESS_SCAN.FOR 

PUTMSG.OBJ depends_on $(SRCDIR)PUTMSG.FOR 

REMOVE_FILE_VERSION.OBJ depends_on $(SRCDIR)REMOVE_FILE_VERSION.FOR 

RESOURCE_LOCK.OBJ depends_on $(SRCDIR)RESOURCE_LOCK.FOR

ROT.OBJ depends_on $(SRCDIR)ROT.FOR 

ROTVC.OBJ depends_on $(SRCDIR)ROTVC.FOR 

SEND_BROADCAST.OBJ depends_on $(SRCDIR)SEND_BROADCAST.FOR 

SEND_MBX_MESSAGE.OBJ depends_on $(SRCDIR)SEND_MBX_MESSAGE.FOR 

SPAWN_AND_READ.OBJ depends_on $(SRCDIR)SPAWN_AND_READ.FOR 

STR_LOWER.OBJ depends_on $(SRCDIR)STR$LOWER.FOR 
  Fortran $(SRCDIR)str$lower/obj=str_lower.OBJ

SWAP_B.OBJ depends_on $(SRCDIR)SWAP_B.FOR 

SWAP_W.OBJ depends_on $(SRCDIR)SWAP_W.FOR 

SWAP_WORDS_F.OBJ depends_on $(SRCDIR)SWAP_WORDS_F.FOR

TAPUSE.OBJ depends_on $(SRCDIR)TAPUSE.FOR 

TIMER_INIT.OBJ depends_on $(SRCDIR)TIMER_INIT.FOR 

UNQUOTE.OBJ depends_on $(SRCDIR)UNQUOTE.FOR 

USERNAME.OBJ depends_on $(SRCDIR)USERNAME.FOR 

USROPN.OBJ depends_on $(SRCDIR)USROPN.FOR 

VMS_GETPID.OBJ depends_on $(SRCDIR)VMS_GETPID.FOR

ISHELL.OBJ depends_on $(SRCDIR)ISHELL.FOR 

SHELL.OBJ depends_on $(SRCDIR)SHELL.FOR 

POLAR.OBJ depends_on $(SRCDIR)POLAR.FOR 

RECTAN.OBJ depends_on $(SRCDIR)RECTAN.FOR 

I2BIT.OBJ depends_on $(SRCDIR)I2BIT.FOR 

OPENFF.OBJ depends_on $(SRCDIR)OPENFF.FOR 

GETPAGESIZE.OBJ depends_on $(SRCDIR)GETPAGESIZE.FOR

STRLEN.OBJ depends_on $(SRCDIR)STRLEN.FOR

LENSTR.FOR depends_on $(SRCDIR)LENSTR.FPP
  FPP -"P" $(SRCSTR)LENSTR.FPP $(SRCSTR)LENSTR.FOR

.FIRST:
       ! MMS begins

.LAST:
       ! MMS Done

