      INTEGER FUNCTION FIND_FILE(search_file,default,result_file)
C
C-----------------------------------------
C
C   Author   :- J.Huber                2-MAR-1991
C
C=========================================
C
C   Purpose   : <title> returns next file name in a sequence of (wildcard) file searches</title>
C   Returned value  : RMS status code (SS$_NORMAL,RMS$_NMF or errors)
C                     RMS$_NMF indicates normal end of the (wildcard-)search
C                     and should be used to terminate the calling loop (would
C                     otherwise start from the beginning at the next call).
C   Inputs    :
C       search_file by descriptor: wildcard expression
C       default     by descriptor: default file specification
C   Outputs   :
C       result_file by descriptor: resulting file name (if success)
C
C   Usage notes:
C       at the end of a search sequence the internal context is reset, i.e.
C       the next call to FIND_FILE will start to return the same list of files.
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      CHARACTER*(*) search_file,default,result_file
      INCLUDE '($RMSDEF)'
      INCLUDE '($LIBDEF)'
      INCLUDE '(LIB$ROUTINES)'

      INTEGER status,context

      INTEGER LIB$M_FIL_MULTIPLE
      PARAMETER (LIB$M_FIL_MULTIPLE=2) !not in $LIBDEF ?

      SAVE context
      DATA context/0/

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      find_file = LIB$FIND_FILE(search_file,result_file,context,
     &  default,,,LIB$M_FIL_MULTIPLE)
      IF (.NOT.find_file) THEN
        status = LIB$FIND_FILE_END(context)
        context=0
      ENDIF
  999 RETURN
      END
