      INTEGER FUNCTION FIND_FILE_C(search_file,default,result_file,rl)
C
C-----------------------------------------
C
C   Author   :- J.Huber                3-MAR-1991
C
C=========================================
C
C   Purpose   : <title>returns next file name in a sequence of file searches: C call </title>
C               (C call interface of FIND_FILE in same library)
C   Returned value  : RMS status code (SS$_NORMAL,RMS$_NMF or errors)
C                     RMS$_NMF indicates normal end of the (wildcard-)search
C                     and should be used to terminate the calling loop (would
C                     otherwise start from the beginning at the next call).
C   Inputs    :
C       search_file by reference : wildcard expression (C string \0 terminated)
C       default     by reference : default file specification (C string \0 term)
C       rl          by reference : maximum length of result_file (integer)
C                                  (not counting the terminating \0)
C   Outputs   :
C       result_file by reference : resulting file name (if success)
C                                  (C string, will be \0 terminated)
C
C   Usage notes:
C       at the end of a search sequence the internal context is reset, i.e. the
C       next call to FIND_FILE_C will start to return the same list of files.
C
C       The default file name will be used for parts of the search-file-name
C       which are not explicitly specified,e.g.
C       FIND_FILE_C('*','.C',...) will return all *.C file in the current
C       directory.
C
C       The output file-name is converted to LOWER case for OS9 convenience .
C
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      INTEGER*2 rl
      BYTE search_file(*),default(*)
      BYTE result_file(0:rl)

      INCLUDE '($DSCDEF)'
      RECORD /DSCDEF1/ DSC_search,DSC_default,DSC_result
      INTEGER*2 rlu

C     external routine references
      INTEGER FIND_FILE                 ! UTIL.OLB
      INTEGER STRLEN                    ! 

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*       make string descriptors for the C-strings
      CALL MAKE_DSC_STR(search_file,STRLEN(search_file),DSC_search)
      CALL MAKE_DSC_STR(default,STRLEN(default),DSC_default)
      CALL MAKE_DSC_STR(result_file,rl,DSC_result)
*       find the next file
      FIND_FILE_C = FIND_FILE(DSC_search,DSC_default,DSC_result)
*       remove trailing blanks and tabs from result
      CALL STR$TRIM(DSC_result,DSC_result,rlu)
*     insert \0 terminator in result string
      result_file(rlu) = 0              ! \0 terminator
*       make result file-name lower case
      CALL STR$LOWER(DSC_result,DSC_result)
      END
