C================== F P A R S E ===================================

      SUBROUTINE FPARSE(LEN,TEXT,NM,BUF,NF,IER)

C==================================================================

	INTEGER LEN,NM,NF,IER
	REAL BUF(NM)
	Character*(*) TEXT
C+
c  <title>    Free format number conversion: </title> 
c
c      CALL FPARSE(LEN,TEXT,NM,BUF,NF,IER)
c
c  Converts up to NM real*4 or integer*4  data from input
c  string 'TEXT' of length 'LEN' into internal numbers stored in 
c  BUF according to their type (real*4 or integer*4).
c  Input can be given in any legal fortran data-format,
c  separated by any character,except  digits,-,+,e,*,.
c  N integers can be given as N*integer
c  multiple komma's (,) as delimeters insert zero for each komma !
c  arguments :
c             NM  = dim of buf/jbuf  (32-bit words)
c             TEXT= textstring to be parsed
c             LEN = length of TEXT in bytes
c  output:     NF  = amount of buf actually filled
c             BUF(1),...,BUF(NF): converted values (real)
c             (the caller must equivalence BUF with an integer*4 array
c              to fetch the integer values, if expected)
c   error/success code is handed back in IER:
c          IER = 1=>success
c          IER = 0: no error but less than nm values are generated
c                       (nf < nm )
c          IER =-16=>an illegal integer repeat-count was found (le 0)
c                       jbuf(nf) in this case holds the cause of error!
C-

      INTEGER ICzero,ICexpo,ICnine,ICastk
      INTEGER NI,NH,NE,NP,NV,NZ
      INTEGER KOMMA,NS(3)	!',' '.-+'
      REAL*8 ZZ,TEN
	real*4 FZH,FZL
	integer*4 IZH,IZL
      EQUIVALENCE (IZL,FZL),(IZH,FZH)
	data ZZ/0.0/,ten/10.0/


	 ns(1) = ichar('.')
	 ns(2) = ichar('-')
	 ns(3) = ichar('+')
	 ICastk = ichar('*')
	 ICzero = ichar('0')
	 ICnine = ichar('9')
	 ICexpo = ichar('E')
	 komma  = ichar(',')

      IER=1
 1111 CONTINUE
      NF=0
 10   CONTINUE
      ZZ=0.0
      NE=0
      NZ=0
      NP=0
      NV=0
      NI=127
C  ----  LOOP OVER THE CHARACTER'S READ INTO text:   -------
	I=1
15	continue
	if (len-I+1) 100,55,16

16	continue
      NH=ichar(text(I:I))
C  NH=INTEGER VALUE OF TOKEN CHAR; IS IT A DIGIT?
      IF(NH.LT.ICzero.OR.NH.GT.ICnine) GOTO 20
C  YES: ADD THE DIGIT TO PREVIOUS TOKEN:
      ZZ=ZZ*TEN+DFLOAT(NH-ICzero)
      NZ=NZ+1
      NE=NE+NP
      GOTO 85
C  NO DIGIT:  CHECK FOR DECIMAL POINT,NEG OR POS SIGN:
   20 DO 30 J=1,3
      IF(NH.EQ.NS(J)) GOTO 40
C  IT'S SOMETHING ELSE:
   30 CONTINUE
      J=0
      JV=0
      GO TO 50
   40 JV=0
      GOTO (42,44,50),J
C  MARK DECIMAL POINT:
   42 NP=1
      GOTO 85
C  SAVE MINUS SIGN:
   44 JV=-1
C   END OF TOKEN;  ANY DIGITS?
   50 CONTINUE
C interpret a komma without preceeding digits as zero
       IF(NH.EQ.KOMMA) GOTO 59
   55 CONTINUE
       IF(NZ.EQ.0) GOTO 80
   59 CONTINUE
C  YES;  IS IT A REAL QUANTITY?
   60 IF(NP.EQ.0) GOTO 61
C  YES;  ADD DIGIT TO REAL QUANTITY, NE>0 ,IF BEHIND DEZIMAL POINT:
C********************************************************************
C  NOTE:NZL=1,0: CURRENT TOKEN INTEGER,REAL
C       LZL=1,0: PREVIOUS TOKEN INTEGER,REAL
C       NI ='E' OR '*' :E OR * WAS FOUND ON A LEGAL PLACE TO
C            INDICATE AN EXPONENT OR REPEATED INTEGER.
C
C********************************************************************
C
      FZL=ZZ/TEN**NE
      NZL=0
      IF(NV.LT.0) FZL=-FZL
      GOTO 62
C  END OF TOKEN,NP=0 => IT'S AN INTEGER QUANTITY:
   61 IZL=ZZ+0.5D0
      NZL=1
      IF(NV.LT.0) IZL=-IZL
C  EXPONENT?
      IF(NI.NE.ICexpo) GOTO 62
C  YES:
C  TO ALLOW EXPONENTIATION WITHOUT EXPLICIT DECIMAL POINT,
C  COMMENT STATEMENT 161:
C161  IF (LZL.EQ.1) GO TO 62
      FZH=0.0
      IF(NF.LE.NM) FZH=BUF(NF)
      IF(LZL.EQ.1) FZH=IZH
      IF(NF.LE.NM)  BUF(NF)=FZH*TEN**IZL
      NI=127
      GOTO 70
C  IS AN INTEGER TO BE REPEATED ?
   62 IF(NI.NE.ICastk.OR.LZL.EQ.0) GOTO 65
C  YES: IN THIS CASE THE REPEAT COUNT IS STORED IN BUF(NF)
      IZH=1
      IF(NF.LE.NM) FZH=BUF(NF)
C   INTEGER-REPEAT COUNT LEGAL?
      IF (IZH)  200,200,63
C  YES: FILL THE REPEATED INTEGERS INTO BUFFER:
 63   NF=NF-1
      DO 64 N=1,IZH
      NF=NF+1
      IF(NF.LE.NM) BUF(NF)=FZL
   64 CONTINUE
      NI=127
      GOTO 70
C  FILL ASSEMBLED VALUE INTO BUFFER:
   65 NF=NF+1
      IF(NF.LE.NM) BUF(NF)=FZL
      LZL=NZL
      NI=0
   70 ZZ=0.0
      NE=0
      NZ=0
      NV=0
   80 NP=0
C
C	statement 83 commented:
C	all constituents of a number (ziphers,operators -+.*E)
C	must be given without separators,i.e.
C	'-1.0E-5' gives ONE real number -1.0E-5,
C	while '- 1. E -5' gives TWO numbers 1.0 and -5,
C	and 5 * 9 is NOT equivalent to 5*9 .
C	In this mode free comments between numbers may include operators
C	(-+.E*); the operators - and + must immediately preceed a number,
C	. must follow a number and E and * must be preceeded and 
C	followed by numbers in order to be recogneized as operators !
C
C	statement 83 activated:
C	constituents of a number may be separated,i.e.
C	'- 1.0 commEnt - 5' gives ONE number -1.0E-5,
C	and '5 and* 9' is equivalent to 5*9 .
C	In this mode, comments between numbers must NOT contain
C	operators (-+.E*) !
C
C 83	IF( NH.NE.ICexpo.AND.NH.NE.ICastk.AND.J.EQ.0) GO TO 85

 84   NV=JV
      IF(J.NE.0) GOTO 85
*   Clear high order bits of NI to avoid overflow:
      NI = NI.AND.'000000FF'X
C   SAVE POSSIBLE 'E' OR '*' SEPARATOR:
      NI=256*NI+NH
 85   CONTINUE

D	type 9085 , text(i:I),NI,np,nv,ne
D9085	format(' debug: ',A1,':ni,np,nv,ne:',4I)

C  BUFFER FULL?
      IF(NF.LT.NM) GO TO 90
C YES:
C  IS VALUE AT BUFFER POSITION NF POSSIBLY INCLOMPLETE?
C  IF '.','E','*' IS PENDING, CONTINUE WITH FOLLOWING CHAR'S
C  ELSE FORGET REST OF text AND RETURN:
      IF (NI .GE. 256) GO TO 100
      IF( NI .EQ. 0 .AND. NP.EQ.0) GO TO 100
C   TAKE THE NEXT CHARACTER FROM text:
 90   CONTINUE
	I=I+1
	go to 15	!next character
 100  NF= MIN0(NF,NM)
      GO TO 900
C  SET RETURN-CODE ,REPEAT-COUNT WAS ILLEGAL AND RETURN
 200  IER=-16
      RETURN
 900  IF (NF.LT.NM) IER=0
      RETURN
          END
