 	INTEGER FUNCTION GBL_SECTION_UFO( blkcnt,file_name,chan )
        IMPLICIT NONE
        Integer blkcnt,chan

        Character*(*) file_name
C   Author   :- J.Huber               1991

C <title> Opens a file to be used as a global section </title>
C An RMS OPEN is performed with the file options (FOP) of 
C User File Open (UFO). The calling routine specifies the
C file name and number of blocks; this routine returns the
C channel number on which the file was opened. 
C If the specified file does not exist, the file is created
C (Except at entry GBL_SECTION_UFO_NOCREATE, which returns an error).
C 
C The calling sequence is
C 
C 	Call GBL_SECTION_UFO( blkcnt,file-name,chan )
C 
C  Where 	
C 		blkcnt => Number of blocks ( file-saize )
C 		file-name => filename descriptor 
C 		chan => channel opened
C 
C 
C 
C Example:
C 	Integer*4 CHANNEL
C 	   :
C 	   :
C 	Call GBL_SECTION_UFO(10,'TEST.DAT',CHANNEL )

        INCLUDE '($SYSSRVNAM)'
        INCLUDE '($FABDEF)'

        RECORD /FABDEF/ FAB
        SAVE FAB
        BYTE A(FAB$C_BLN)
        EQUIVALENCE(FAB,A)

        INTEGER I,MODE,STATUS

C entry points
        INTEGER GBL_SECTION_UFO_NOCREATE
        INTEGER GBL_SECTION_UFO_RO
        INTEGER GBL_SECTION_UFO_CLOSE

        MODE=1

100     CONTINUE
         
        DO i=1,FAB$C_BLN
          A(I)=0
        END DO
        FAB.FAB$B_BID = FAB$C_BID
        FAB.FAB$B_BLN = FAB$C_BLN

	FAB.FAB$B_FNS = LEN(file_name)  !Store name length in FAB
	FAB.FAB$L_FNA = %LOC(file_name) !And file name
	
	FAB.FAB$L_ALQ = blkcnt 	!Number of blocks to allocate
        FAB.FAB$L_FOP = FAB$M_UFO.OR.FAB$M_CIF.OR.FAB$M_CBT
	FAB.FAB$B_FAC = FAB$M_PUT.OR.FAB$M_GET    !write access
	FAB.FAB$B_SHR = FAB$M_SHRPUT.OR.FAB$M_SHRGET.OR.FAB$M_UPI

        IF (mode.gt.1) FAB.FAB$L_FOP=IBCLR(FAB.FAB$L_FOP,FAB$V_CIF)
        IF (mode.gt.2) THEN
          FAB.FAB$B_FAC=IBCLR(FAB.FAB$B_FAC,FAB$V_PUT)
          FAB.FAB$B_SHR=IBCLR(FAB.FAB$B_SHR,FAB$V_SHRPUT)       
        ENDIF
	IF (BTEST(FAB.FAB$L_FOP,FAB$V_CIF)) THEN
	STATUS=SYS$CREATE(FAB)		!Open data file, Create it if
					!if it does not exist
        ELSE
	STATUS=SYS$OPEN(FAB)		!open, don't create
        ENDIF
	chan=FAB.FAB$L_STV    !Store channel number			
        GBL_SECTION_UFO=STATUS
        RETURN

	ENTRY GBL_SECTION_UFO_NOCREATE( blkcnt,file_name,chan )
C  do not create file, but have write access:
        MODE=2
	GOTO	100

	ENTRY GBL_SECTION_UFO_RO( blkcnt,file_name,chan )
C do not create file, no write access, only read:
        MODE=3
	GOTO	100

	ENTRY	GBL_SECTION_UFO_CLOSE()
        GBL_SECTION_UFO_CLOSE=SYS$CLOSE(FAB)
        END
