*  GETCML.FOR get-commandline interface for VMS
	Integer Function GetCML(line,prompt)
*	J.Huber , 1988
*++
* <title> Returns foreign DCL commandlines </title>
*	Integer Function GetCML(line,prompt) !upper case, no comments
*	Integer Function GetCML_with_comments(line,prompt) !upper case
*	Integer Function GetCML_asis(line,prompt) !case as is,no comments
*
*	Trailing comments (right of '!') removed.
*	Comment lines (starting with ';' or '!') are not returned 
*	(except if entry at GCML_with_comments).
*--
	Implicit NONE	!force strong typing
	Character*(*) line,prompt

	Include '($LIBDEF)'

	Include 'GCML$CODES.INC'
	Logical LIB$GET_FOREIGN,LIB$GET_INPUT
	Logical LIB$GET_LUN ,LIB$FREE_LUN
	Integer STR$FIND_FIRST_NOT_IN_SET
	Integer getCML_with_comments	!entry name
	Integer getCML_asis	!entry name
	Logical Lcond
	Integer Icond,i,is
	Logical Lcode
	Integer Icode
	Equivalence (Lcode,Icode)
	Integer*2 I2cond,LineL
	Equivalence (Lcond,Icond,I2cond)
	Character*2 separator
	Logical Skip_comment,asis
	Integer max_files
	Parameter (max_files=5)	!number of (nested) command files
	Integer act_lun,luns
	Logical foreign_cmd,ind_file,first_call
	Character*64 ind_file_name(max_files)
	Common /Flags_getCML/foreign_cmd,ind_file,act_lun,
	1 luns(max_files),ind_file_name
	Volatile /Flags_getCML/

	Data first_call/.true./

	Skip_comment = .true.
        asis = .false.

100	Continue
	LineL = 0

	DO WHILE (LineL.eq.0)
	Line = ' '
	If (first_call) Then
	 separator = ' '//char(9)
	 LineL = GCML$_EOF	!at entry assume EOF
	 first_call=.false.
	 act_lun=0
	 foreign_cmd=.false.
	 ind_file=.false.
*	try to get a 'foreign' commandline
	 LineL = 0
	 Lcode = LIB$GET_Foreign(line,,linel,)
	 If ((Lcode.or.(Icode.eq.LIB$_INPSTRTRU)).and.Linel.gt.0)
	1 Then
	  foreign_cmd = .true.
	 Endif
	Endif


	 Do While ((act_lun.gt.0).and.(linel.eq.0))
	 Read(luns(act_lun),'(Q,A)',end=110,err=120) linel,line
	 Go to 130
110	 Continue
	 linel = 0
111	 Close(unit=luns(act_lun))
	 Lcond = LIB$FREE_LUN(luns(act_lun))
	 act_lun = act_lun-1
	 ind_file = act_lun.gt.0
	 If (.not.ind_file.and.foreign_cmd) Then 
	  If (linel.eq.0) linel=GCML$_EOF
	  GetCML=linel
	  Return
	 Endif
	 Go to 130
120	 Continue
	 linel=GCML$_ERR
	 Go to 111
130	 Continue
	 End Do  !act_lun


	If ((linel.eq.0).and..not.foreign_cmd) Then
*	read from SYS$INPUT with prompt
	 Lcode = LIB$GET_Input(line,prompt,linel,)
	 If (.not.Lcode.and.(Icode.ne.LIB$_INPSTRTRU))
	1                 LineL=GCML$_EOF
	Endif

	If (LineL.gt.0) Then
	 I = STR$FIND_FIRST_NOT_IN_SET(line,separator)
	 If (I.gt.0) Then
	  Call STR$RIGHT(line,line,I)
	  linel = linel-I+1
	 Endif	
         If (.NOT.asis) Then
	  Call STR$UPCASE(line,line)	!convert to upper case
         Endif
	 Call STR$TRIM(line,line,linel)	!remove trailing blanks and tabs
	Endif

	If (LineL.gt.0) Then
*	skip over leading blanks and tabs
	is = 0
	 Do I=1,linel
	  if (line(i:i).ne.' '.and.line(i:i).ne.char(9)) goto 220
	  is = is+1
	 End Do
220	Continue
	linel = linel-is
	if (is.gt.0.and.linel.gt.0) line = line(is+1:)
	linel = max(linel,0)
	Endif

	If (Skip_comment) Then
*	 ignore lines starting with a semicolon or exclamation mark
	 If (linel.gt.0.and.line(1:1).eq.';') linel=0
	 If (linel.gt.0.and.line(1:1).eq.'!') linel=0
	EndIf
	If (linel.gt.0) Then
*	Always remove trailing comments (delimiter is !)
	 is = index(line,'!')
	 If (is.gt.0) Then
	  Call STR$LEFT(line,line,is-1)
	  Call STR$TRIM(line,line,linel)	!remove trailing blanks and tabs
	 Endif
	Endif
		 
*	is it an indirect command starting with '@' ?
	If (linel.gt.0) Then
	 If (line(1:1).eq.'@') Then
	  If (act_lun.eq.max_files) Then
	   GetCML = GCML$_DEEP
	   Return
	  Endif
	  If (.not.LIB$GET_LUN(luns(act_lun+1))) Then
	   GetCML = GCML$_LUN
	   Return
	  Endif
	  ind_file_name(act_lun+1) = line(2:)
	  Open(unit=luns(act_lun+1),name=ind_file_name(act_lun+1),
	1 Type='OLD',READONLY,Err=420)
	  act_lun=act_lun+1
	  linel = 0
	  ind_file = .true.
	  Go to 430
420	  Continue
	  linel = GCML$_OPEN
430	  Continue
	 Endif
	Endif

	If (.not.ind_file.and.(linel.eq.0).and.foreign_cmd) Then
	 linel = GCML$_EOF
	Endif

	End Do !while linel.eq.0
	GetCML = LineL
	Return

	Entry GetCML_with_comments(line,prompt)
	Skip_comment = .false.
        asis = .false.
	Go to 100

	Entry GetCML_asis(line,prompt)
	Skip_comment = .true.
        asis = .true.
	Go to 100

	End
