
<TITLE>HG$GET_INPUT provide command recall when reading from SYS$INPUT</TITLE>
 This is a Fortran 90 version of the original Vax Macro routine written
 by Hunter Goatley.
 Coding by Joseph Huber.
++
  Routine:     HG$GET_INPUT
  Author:      Hunter Goatley, Western Kentucky University
               goathunter@WKUVX1.BITNET
  Date:        January 18, 1988
  Functional Description:

       This routine implements an easy-to-call interface to the SMG$ routines
       to provide command recall when reading from SYS$INPUT.  It takes
       the same arguments as LIB$GET_INPUT and may be substituted directly
       in any call to LIB$GET_INPUT.

       Example:
               CALL LIB$GET_INPUT (buffer, prompt, lbuffer)
                       to
               CALL HG$GET_INPUT (buffer, prompt, lbuffer)

       HG$GET_INPUT  get-str [,prompt-str] [,out-len]
  Inputs:
       get-str - String which is read from SYS$INPUT.
                 Address of string descriptor.   Write-only.
       prompt  - Prompt message that is displayed.
                 Address of string descriptor.  Read-only.
       out-len - Number of bytes written into get-str.
                 Address of word.  Write-only.
  Returns:
       String in get-str and status in return code.
  Effects:
       On first call, a key table and a virtual keyboard are created.
-

NTEGER FUNCTION HG$GET_INPUT(buf, prompt, lbuf )
MPLICIT NONE

HARACTER (LEN=*), INTENT(OUT)   :: buf
NTEGER (KIND=4),OPTIONAL, INTENT(IN) :: prompt !cheat type:safe if missing
NTEGER (KIND=2),OPTIONAL, INTENT(IN OUT):: lbuf

NCLUDE '($rmsdef)'                     ! RMS symbols */
NCLUDE '($ssdef)'                      ! System service status symbols */
NCLUDE '($smgdef)'                     ! SMG$ symbols */
NCLUDE '($smgmsg)'                     ! SMG$ symbols */
NCLUDE '(smg$routines)'

NTEGER :: key_table_id    !! ID of key table created*/
NTEGER :: keyboard_id     !! ID of virtual keyboard created*/

NTEGER (KIND=2) , POINTER :: mylbuf => NULL()
NTEGER , POINTER :: myprompt => NULL()

ATA key_table_id /0/
ATA keyboard_id /0/
AVE key_table_id
AVE keyboard_id

G$GET_INPUT = 1
F ( key_table_id == 0) THEN
 HG$GET_INPUT = smg$create_key_table(key_table_id)
 IF (hg$get_input) hg$get_input = smg$create_virtual_keyboard(keyboard_id)
ND IF
F (.NOT.HG$GET_INPUT) RETURN

F ((iargcount() > 1) .AND. PRESENT(prompt))  myprompt => prompt
F ((iargcount() > 2) .AND. PRESENT(lbuf))  mylbuf => lbuf

HG$GET_INPUT = &
smg$read_composed_line(keyboard_id,key_table_id,buf,myprompt,mylbuf)

 Was ^Z entered? Make status RMS$_EOF */
F (HG$GET_INPUT == smg$_EOF) HG$GET_INPUT=rms$_EOF!
ND FUNCTION HG$GET_INPUT
