/*<title> initialize CLI table parsing for C argv array</title> */
/* a variant of init_cli, uses C main arguments as input 
 Author: Joseph Huber
*/

#include string
#include stdlib
#include climsgdef
#include descrip
#include lib$routines
#include cli$routines

#include "init_cli_argv.h"
/* "table" is a pointer to the internal CLI table (set command/object)
 * "verb" is a text string containing the name of the verb   
 * argc,argv passed from main(int argc, char *argv[])
 */

int init_cli_argv(char *table, char *verb, int argc, char *argv[])
{ 

  char *command_string;
  long status, count, command_length;
  struct dsc$descriptor command_descriptor = {0, DSC$K_DTYPE_T, DSC$K_CLASS_D, 0};


  command_length = strlen(verb) + sizeof(0);
  for (count = 1 ; count < argc ; count++)
     command_length = command_length + strlen(argv[count]) + sizeof(" ");

/*  malloc here, free nowhere: init_cli to be called once in program! */
   command_string = malloc(command_length);
   strcpy(command_string, verb);
   strcat(command_string," ");
   for (count = 1 ; count < argc ; count++)
           strcat(strcat(command_string, argv[count]), " ");

   command_descriptor.dsc$a_pointer = command_string;
   command_descriptor.dsc$w_length = strlen(command_string);

   status = CLI$DCL_PARSE(&command_descriptor, table, LIB$GET_INPUT, LIB$GET_INPUT);
   free(command_string);
   return status;
}

#ifdef TEST
/* link test with a command definition like this:
module  TEST_TABLE
ident   "01-000"
define verb TEST
        parameter P1,
                prompt="Process ID",
                value(required)
        qualifier STATUS,
                default,
                nonnegatable,
                value(type = $NUMBER, default = "1")
*/

#include stdio
int  main( int argc, char *argv[]) 
{ 
 int status;

        char p1_string[20];
        $DESCRIPTOR(p1_entity, "P1");     
        $DESCRIPTOR(p1_descriptor, p1_string);
        short p1_length;
        char status_string[11];
        $DESCRIPTOR(status_entity, "STATUS");
        $DESCRIPTOR(status_descriptor, status_string);
        short status_length;


        extern char test_table;
 
 status = init_cli_argv( &test_table, "TEST", argc, argv );
        if (!(status & 1)) exit(status);

        status = CLI$GET_VALUE(&p1_entity, &p1_descriptor, &p1_length);
        if (!(status & 1)) exit(status);
        p1_string[p1_length]='\0';
        printf("P1=%s\n",p1_string);
        status =
CLI$GET_VALUE(&status_entity,&status_descriptor,&status_length);
        if (!(status & 1)) exit(status);          
        status_string[status_length]='\0';
        printf("Status=%s\n",status_string);

}
#endif

