        OPTIONS /EXTEND_SOURCE
	integer function init_cli_for(table, name)
*<META name="keywords" content="init,CLI,DCL,VMS">
*<TITLE>DCL parsing of foreign command-lines (Fortran call)</TITLE> 
*<pre>
* Joe Meadows wrote the original code in C
* Fortran version by Joseph Huber

* "table" is a pointer to the internal CLD
* "name" is a text string containing the name of the verb
!! other than init_cli.c, name is string descriptor, not a C char* !!

       implicit NONE
       
       byte table(*)
       character*(*) name
       
      include '($clidef)'
      include '(cli$routines)'
      include '(lib$routines)'
      
      character*4096 cmd
      character*32 verb 
      integer*2 ll,lv
      integer i
 
      ll=0
!verb defined by set command properly ?
! if verb is exactly matching name,assume defined in dcltables.
! this may give false "true" if the command is defined by "set command" 
! and also defined as a foreign command with same as verb !
! A check for foreign commandline availability needed,
! but this always succeeds except when invoked by RUN file.
! So the following may fail if symbol = verb in DCLtables,
! that should be avoided .
D      print * , ' at get_value VERB'
      call lib$establish(lib$sig_to_ret)
      init_cli_for = cli$get_value('$VERB',verb,lv);
      if (.NOT.init_cli_for) return
D      print *, ' Verb from CLI:',verb(1:lv)
      if (verb(1:lv).eq.name) return !assume parsed dcltables

* get the whole command-line
D      print * , ' at get_value LINE'
      call lib$establish(lib$sig_to_ret)
      init_cli_for = cli$get_value('$LINE',cmd,ll)
      if (.NOT.init_cli_for) return
D     print *,' line is:',cmd(1:ll)

* in case of invocation by "RUN image" replace by name,
* and let cli$dcl_parse ask for parameters/qualifiers
      if (verb.eq.'RUN') then
       i=INDEX(cmd,' ')
       if (i.gt.0) then
         lv=INDEX(cmd(i:),' ')
         if (lv.gt.0)  cmd(1:lv+i-1)=name
       endif
      endif

* replace the verb in line by the one in the cld 
* check if the command is invoked by MCR filename param... 
* if so, fill space behind MCR to skip over verb
      if (ll.gt. 3) then
       if (cmd(1:4).eq.'MCR ')  cmd(4:4)='X'
      endif
      lv=LEN(name)
      i=1
      do while ((i.le.ll).and.(cmd(i:i).ne.' ').and.(cmd(i:i).ne.'/'))
      if (i.le.lv) then         
       cmd(i:i) = name(i:i)
      else
       cmd(i:i) = ' '
      endif
      i=i+1
      enddo
D     print *,' cmd is:',cmd(1:ll)
      call lib$establish(lib$sig_to_ret)
      init_cli_for = cli$dcl_parse(cmd(1:ll),table,LIB$GET_INPUT,LIB$GET_INPUT)
      end
