!<TITLE> Converts FORTRAN IOSTAT value to a VMS condition code </TITLE>
!From: lionel@quark.enet.dec.com (Steve Lionel)
!Subject: Re: Turning VAX FORTRAN IOSTAT returns into VMS status codes?
!Date: Thu, 12 Nov 1992 15:06:39 GMT

!It's a bit wordier than I might have hacked
!up on my own but I wanted it to be understandable.  
!The key notion is that the IOSTAT value is just the "message number" 
!part of a VMS condition code using the FOR$ (FORTRAN Run-Time Library) 
!facility.  
!Note that you can't recover the severity of the original error 
!except by using knowledge of how it was assigned, which I have done here.
!Steve Lionel                    lionel@quark.enet.dec.com
!SDT Languages Group Digital Equipment Corporation
 
	INTEGER*4 FUNCTION IOSTAT_TO_STATUS (IOSTAT)
C 
C FUNCTIONAL DESCRIPTION:
C 
C     Converts FORTRAN IOSTAT value to a VMS condition code suitable for
C     use by LIB$SIGNAL
C 
C FORMAL PARAMETERS:
C  
C     IOSTAT:
C	  The IOSTAT value to be converted, INTEGER*4
C   
C FUNCTION VALUE:
C 
C     The VMS condition code equivalent of the IOSTAT value argument.
C 
	IMPLICIT NONE
	INTEGER*4 IOSTAT
	INCLUDE '($FORDEF)' ! FORTRAN RTL error message codes
	INCLUDE '($FORIOSDEF)'	! IOSTAT definitions
	INCLUDE '($STSDEF)' ! VMS condition code format
	INCLUDE '($SSDEF)'  ! VMS statuses
 
	! Define base message code value
	!
	INTEGER*4 FORMSG_BASE
	PARAMETER (FORMSG_BASE =
	1  ISHFT(FOR$_FACILITY,STS$V_FAC_NO) +    ! FOR$ facility code
	2  STS$M_FAC_SP)			    ! Facility specific
 
	! IOSTAT of zero means success
	!
	IF (IOSTAT .EQ. 0) THEN
	    IOSTAT_TO_STATUS = SS$_NORMAL
	!
	! Negative IOSTAT means end of file
	!
	ELSE IF (IOSTAT .LT. 0) THEN
	    IOSTAT_TO_STATUS = FOR$_ENDDURREA
	!
	! Otherwise IOSTAT is MSG_NO part of message with F severity
	! (except for OUTCONERR which is E severity)
	!
	ELSE
	    IF (IOSTAT .EQ. FOR$IOS_OUTCONERR) THEN
	      IOSTAT_TO_STATUS = FOR$_OUTCONERR
	    ELSE
	      IOSTAT_TO_STATUS = FORMSG_BASE +
	1       ISHFT(IOSTAT,STS$V_MSG_NO) + STS$K_SEVERE
	    END IF
	END IF
	RETURN
	END
