      INTEGER FUNCTION LENSTR(string)
C-----------------------------------------
C   Author   :- J.Huber     18-JUL-1991
C=========================================
C   Purpose   : <title> Position of last non-blank char in a string </title>
C   Inputs    : string
C   Outputs   : length of string without trailing blanks
C=========================================
      IMPLICIT NONE
      Character*(*) string
#ifdef USE_TRIM
C it would be easier to simply loop over string from the end
C and count blanks, but here I want to use VMS RTL str$trim.
C the trim into tstring is needed to make lenstr callable
C with literal strings, which are allocated in RO memory

      integer lenstr_trim
      external lenstr_trim
	
      LENSTR = lenstr_trim(string,LEN(string))
      End

      integer function lenstr_trim(string,length)
      IMPLICIT NONE
      integer*2 length,tlength
      character*(*) string
      character tstring(length)

      Call STR$TRIM(tstring,string,tlength)
      lenstr_trim=tlength
#else
C This is the simpler stuff, need no writable argument, and no copy.

      Integer i

      LENSTR=0
      Do i=1,LEN(string)
        If( string(i:i).ne.' ' ) LENSTR=i
      Enddo  

#endif
      End
