/*<title> Pop up window to confirm or quit </title>
   Exit status code (DCL symbol $STATUS):
   1 confirm
   3 cancel
*/
#include stdio
#include stdlib
#include <errno.h>
#include <Xm/Xm.h>                   /* Motif Toolkit */
#include <Mrm/MrmPublic.h>           /* Mrm stuff */

static MrmHierarchy	s_MrmHierarchy;		/* MRM database hierarch id */

static char *vec[]={"askok"}; 
static char *vec1[]={"DECW$USER_DEFAULTS:askok.uid"}; 
static char *vec2[]={"DECW$SYSTEM_DEFAULTS:askok.uid"}; 

						
static MrmCode		class ;

static void ok_button_activate();
static void c_button_activate();

static MrmRegisterArg	regvec[] = {
	{"ok_button_activate",(caddr_t)ok_button_activate},
	{"c_button_activate",(caddr_t)c_button_activate},
	};
static MrmCount regnum = sizeof(regvec) / sizeof(MRMRegisterArg);

static int st;

/*
 *  Main program
 */
int main(argc, argv)
int argc;
char **argv;
{
    XtAppContext            app_context;
    Widget toplevel, askok = NULL;

    st = 0;
    MrmInitialize ();
    toplevel = XtAppInitialize(&app_context, "askok", NULL, 0,
			       &argc, argv, NULL, NULL, 0);
    if (MrmOpenHierarchy (sizeof(vec) / sizeof(char*), vec, NULL, &s_MrmHierarchy) != MrmSUCCESS) {
    if (MrmOpenHierarchy (sizeof(vec1) / sizeof(char*), vec1, NULL, &s_MrmHierarchy) != MrmSUCCESS) {
    if (MrmOpenHierarchy (sizeof(vec2) / sizeof(char*), vec2, NULL, &s_MrmHierarchy) != MrmSUCCESS) {
	printf ("can't open hierarchy askok.uid\n");
	exit(EXIT_FAILURE);
     }
     }
     }

    if (MrmRegisterNames (regvec, regnum)!= MrmSUCCESS) {
	printf("can't register names\n");
	exit(EXIT_FAILURE);
    }

    if (MrmFetchWidget (s_MrmHierarchy, "ask", toplevel,
			&askok, &class) != MrmSUCCESS) {
	printf("can't fetch interface\n");
	exit(EXIT_FAILURE);
    }

    XtManageChild(askok);
    
    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}



static void ok_button_activate( widget, tag, callback_data )
	Widget	widget;
	char    *tag;
	XmAnyCallbackStruct *callback_data;
{
	exit(1);
}

static void c_button_activate( widget, tag, callback_data )
	Widget	widget;
	char    *tag;
	XmAnyCallbackStruct *callback_data;
{
	exit(3);
}
