!<TITLE>binary_date - return binary time (hexadecimal) in a symbol </TITLE>
! Author: Joseph Huber

            Program Binary_Date

! binary_date symbol absolute_date_time_string
!  p1 = symbol to store resulting binary time
!  p2 = absolute date_time string
! /HELP : display description

#ifdef __vax
! version also running on 32-bit machines
#else
! runs on 64bit machines only 
#endif

	external BINARY_DATE_TABLE
! BINARY_DATE_TABLE points to a CLI table defined like:
!Module BINARY_DATE_TABLE
!Define Verb BINTIM
!Parameter P1
! Value (Type=$INSYM, Default="BINTIM_HEX")
!Parameter P2
! Value (Type=$DATETIME)
!Qualifier HELP

        Include '($SYSSRVNAM)'
	INCLUDE '($CLIDEF)'
	INCLUDE '(CLI$routines)'
	INCLUDE '(LIB$ROUTINES)'
	INCLUDE '($LIBDEF)'

	character*40 s_time1
	character*16 s_hex
	character*20 symbol
	integer*2 ll1,lls
#ifdef __vax
        integer*4 Bintim(2)
#else
	integer*8 Bintim
#endif
	integer status

	call init_cli_for(BINARY_DATE_TABLE,'BINTIM')

	if (cli$present('HELP')) then
	Print *,' BINARY_DATE symbol date_time'
	Print *,' Returns in the specified DCL symbol the'
	Print *,' hexadecimal value (quadword VMS time) of date_time'
	Call Exit(1)
	endif

      symbol = 'BINTIM_HEX'
      lls = 10
      s_time1 = ' '
      ll1=1
      
      IF (cli$present('P1')) THEN
        status=cli$get_value('P1',symbol,lls)
      ENDIF
      IF (cli$present('P2')) THEN
        status=cli$get_value('P2',s_time1,ll1)
      ENDIF

	IF (s_time1.ne.' ') THEN
	 status = SYS$BINTIM(s_time1,Bintim)
	 if (.NOT.status) call EXIT(status)
	ELSE
	 status = SYS$GETTIM(Bintim)
	ENDIF

#ifdef __vax
	write (s_hex,'(2Z8.8)') Bintim(1),Bintim(2)
#else
	write (s_hex,'(Z16.16)') Bintim
#endif

	call EXIT(LIB$SET_SYMBOL(symbol(1:lls),s_hex))
	END
