      OPTIONS /EXTEND_SOURCE
      PROGRAM BROADCAST
C
C-----------------------------------------
C
C   Author   :- J.Huber                1-APR-1993
C
C=========================================
C
C   Purpose   : send a message to another user in the cluster
C   Inputs    : DCL foreign command line
C          BROADCAST username "message"
C          If no message, message(s) are read from sys$input
C   Outputs   : broadcast sent to all username terminals
C
C        Copyright (C) 1993   Joseph Huber (huber@mppmu.mpg.de)

C        This program is free software; you can redistribute it and/or modify
C        it under the terms of the GNU General Public License as published by
C        the Free Software Foundation; either version 2 of the License, or
C        (at your option) any later version.
C        This program is distributed in the hope that it will be useful,
C        but WITHOUT ANY WARRANTY; without even the implied warranty of
C        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C        GNU General Public License for more details.
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      INCLUDE '($libdef)'
      INCLUDE '($SSdef)'
      INCLUDE '($STSDEF)'
      INCLUDE '($IOdef)'
      INCLUDE '($CLIDEF)'
      INCLUDE '(LIB$ROUTINES)'
      INCLUDE '(STR$ROUTINES)'
      INCLUDE '(CLI$routines)'

      INTEGER send_broadcast
      INTEGER USERNAME
      CHARACTER*255 line
      CHARACTER*255 userlist
      CHARACTER*12 user,sender
      INTEGER code,pid,iostat
      INTEGER*2 ll,llu,lls
      LOGICAL textfile,more
      integer reqid
      
      integer CLI$_NEGATED
      external CLI$_NEGATED
      integer broadcast_cli_table
      external broadcast_cli_table
      integer iostat_to_status
      external iostat_to_status
      integer init_cli_for
      external init_cli_for
      integer unquote
      external unquote
      integer broadcast2reqid
      external broadcast2reqid

      DATA textfile/.TRUE./
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ll = 0
      pid = 0
      reqid=0
      code = USERNAME(sender)
      IF (.NOT.code) CALL exit(code)
      call STR$TRIM(sender,sender,lls)
      code = init_cli_for(broadcast_cli_table,'BROADCAST')
      IF (.NOT.code) CALL exit(code)
! get list of users, concatenate again to pass it to send_broadcast
      llu=0
      IF (cli$present('P1')) THEN
        DO WHILE (code)
         code=cli$get_value('P1',user,ll)
         IF (code) THEN
          call str$trim(user,user,ll)
          IF (llu.eq.0) THEN
           userlist=user(1:ll)
          ELSE
           userlist=userlist(1:llu)//','//user(1:ll)
          ENDIF
          call str$trim(userlist,userlist,llu)
         ENDIF
        ENDDO
      ENDIF
      line = " "
      IF (cli$present('CLASS')) THEN
        code=cli$get_value('CLASS',line,ll)
        if (code) reqid=broadcast2reqid(line(1:ll))
      ENDIF
      ll=0
      IF (cli$present('P2')) THEN
        code=cli$get_value('P2',line,ll)
        textfile=.FALSE.
      ENDIF
      IF (ll.GT.0) THEN
! do a simple unquote not handling nested quotes
       ll = unquote(line(1:ll),line)
      ENDIF
      code = 1
      more = .TRUE.
      DO WHILE (more)
        IF (textfile) THEN
         more=LIB$GET_INPUT(line,'Message:',ll)
        ELSE     
         more=.FALSE.
        ENDIF
        IF (ll.gt.0) THEN
         line = ' '//sender(1:lls)//': '//line(1:ll)
         CALL STR$TRIM(line,line,ll)
         code = send_broadcast(userlist,line(1:ll),reqid)
        ENDIF
      ENDDO
* DEVOFFLINE is returned when sending accross cluster nodes,even if success!
      IF (code.EQ.SS$_DEVOFFLINE) CODE=SS$_NORMAL
      CALL exit(code)

      END
