!<TITLE>F$ADD_TIME - add two dates/times </TITLE>
! Author: Joseph Huber
C        Copyright (C) 2005   Joseph Huber (huber@mppmu.mpg.de)

C        This program is free software; you can redistribute it and/or modify
C        it under the terms of the GNU General Public License as published by
C        the Free Software Foundation; either version 2 of the License, or
C        (at your option) any later version.

C        This program is distributed in the hope that it will be useful,
C        but WITHOUT ANY WARRANTY; without even the implied warranty of
C        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C        GNU General Public License for more details.



          Program ADD_TIME

! the program can be called as a foreign command:

! F$delta_time symbol start end
!  p1 = symbol to store resulting time
!  p2 = first time
!  p3 = second time
! /HELP : display description

	external ADD_TIME_TABLE
! ADD_TIME_TABLE points to a CLI table defined like:
!Module ADD_TIME_TABLE
!Define Verb ADD_TIME
!Parameter P1
! Value (Type=$INSYM, Default="TIME_SUM")
!Parameter P2
! Value (Type=$DATETIME)
!Parameter P3
! Value (Type=$DELTATIME)
!Qualifier HELP

        Include '($SYSSRVNAM)'
	INCLUDE '($CLIDEF)'
	INCLUDE '(CLI$routines)'
	INCLUDE '(LIB$ROUTINES)'
	INCLUDE '($LIBDEF)'

	character*40 s_time1,s_time2,s_delta
	character*20 symbol
	integer*2 ll1,lls
	integer status

	Integer*8 Time1,Time2,delta
	Time1 = 0
	Time2 = 0


	call init_cli_for(ADD_TIME_TABLE,'ADD_TIME')

	if (cli$present('HELP')) then
	Print *,' F$ADD_TIME symbol time1 time2'
        Print *,' At least one of time1,time2 must be a delta-time'
	Print *,' Returns the sum of both dates/times'
	Call Exit(1)
	endif

      symbol = 'TIME_SUM'
      lls = 5
      s_time1 = ' '
      s_time2 = ' '
      ll1=1
      
      IF (cli$present('P1')) THEN
        status=cli$get_value('P1',symbol,lls)
      ENDIF
      IF (cli$present('P2')) THEN
        status=cli$get_value('P2',s_time1,ll1)
      ENDIF
      IF (cli$present('P3')) THEN
        status=cli$get_value('P3',s_time2,ll1)
      ELSE
        s_time2 = s_time1
      ENDIF

	IF (s_time1.ne.' ') THEN
	 status = SYS$BINTIM(s_time1,Time1)
	 if (.NOT.status) call EXIT(status)
	ELSE
	 status = SYS$GETTIM(Time1)
	ENDIF
	IF (s_time2.ne.' ') THEN
	 status = SYS$BINTIM(s_time2,Time2)
	 if (.NOT.status) call EXIT(status)
	ELSE

	 Time2 = 0

	ENDIF
        s_delta=' '
	status = LIB$ADD_TIMES(Time1,Time2,delta)
	if (.NOT.status) call EXIT(status)
	status = SYS$ASCTIM(,s_delta,delta,%VAL(0))
	if (.NOT.status) call EXIT(status)
        Call STR$TRIM(s_delta,s_delta,ll1)
	call EXIT(LIB$SET_SYMBOL(symbol(1:lls),s_delta(1:ll1)))
	END
