!<TITLE>F$DELTA_TIME - compute difference between 2 dates to a delta time</TITLE>
! Author: Joseph Huber
C        Copyright (C) 2005   Joseph Huber (huber@mppmu.mpg.de)

C        This program is free software; you can redistribute it and/or modify
C        it under the terms of the GNU General Public License as published by
C        the Free Software Foundation; either version 2 of the License, or
C        (at your option) any later version.

C        This program is distributed in the hope that it will be useful,
C        but WITHOUT ANY WARRANTY; without even the implied warranty of
C        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C        GNU General Public License for more details.



          Program DELTA_TIME
          Implicit NONE
! the program can be called as a foreign command:

! F$delta_time symbol start end
!  p1 = symbol to store resulting delta time
!  p2 = start time (the earlier)
!  p3 = end time (the later)
! /HELP : display description
! /DCL  : delta-time with "-" as in "dddd-time", otherwise in WAIT format (dddd time)

	external DELTA_TABLE
! DELTA_TABLE points to a CLI table defined like:
!Module DELTA_TABLE
!Define Verb DELTA
!Parameter P1
! Value (Type=$FILE, Default="DELTA")
!Parameter P2
! Value (Type=$DATETIME)
!Parameter P3
! Value (Type=$DATETIME)
!Qualifier HELP
!Qualifier DCL

        Include '($SYSSRVNAM)'
	INCLUDE '($CLIDEF)'
	INCLUDE '(CLI$routines)'
	INCLUDE '(LIB$ROUTINES)'
	INCLUDE '($LIBDEF)'

	character*40 s_time1,s_time2,s_delta
	character*20 symbol
	integer*2 i,ll1,lls
	integer status
	logical DCL
#ifdef __vax
	Integer*4 Time1(2),Time2(2),delta(2)
	Time1(1) = 0
	Time1(2) = 0
	Time2(1) = 0
	Time2(2) = 0
#else
	Integer*8 Time1,Time2,delta
	Time1 = 0
	Time2 = 0
#endif

	call init_cli_for(DELTA_TABLE,'DELTA')

	if (cli$present('HELP')) then
	Print *,' F$DELTA_TIME symbol starttime endtime'
	Print *,' Returns the delta-time from starttime to endtime'
	Print *,' in the specified DCL symbol, in the form dddd hh:mm:ss.'
	Print *,' endtime must be in the future of starttime.'
	Print *,' qualifier /DCL: replace " " by "-" in dddd hh:mm:ss'
	Call Exit(1)
	endif

      DCL=.FALSE.
      symbol = 'DELTA'
      lls = 5
      s_time1 = ' '
      s_time2 = ' '
      ll1=1
      
      DCL = cli$present('DCL')

      IF (cli$present('P1')) THEN
        status=cli$get_value('P1',symbol,lls)
      ENDIF
      IF (cli$present('P2')) THEN
        status=cli$get_value('P2',s_time1,ll1)
      ENDIF
      IF (cli$present('P3')) THEN
        status=cli$get_value('P3',s_time2,ll1)
      ELSE
        s_time2 = s_time1
      ENDIF

	IF (s_time1.ne.' ') THEN
	 status = SYS$BINTIM(s_time1,Time1)
	 if (.NOT.status) call EXIT(status)
	ELSE
	 status = SYS$GETTIM(Time1)
	ENDIF
	IF (s_time2.ne.' ') THEN
	 status = SYS$BINTIM(s_time2,Time2)
	 if (.NOT.status) call EXIT(status)
	ELSE
#ifdef __vax
	 Time2(1) = Time1(1)
	 Time2(2) = Time1(2)
#else
	 Time2 = Time1
#endif
	ENDIF
        s_delta=' '
	status = LIB$SUB_TIMES(Time2,Time1,delta)
	if (.NOT.status) call EXIT(status)
	status = SYS$ASCTIM(,s_delta,delta,%VAL(0))
	if (.NOT.status) call EXIT(status)
        Call STR$TRIM(s_delta,s_delta,ll1)
	i=1
	if (ll1.gt.0) then
	 do while (s_delta(i:i).eq.' ')
	   s_delta(i:i)='0' ! insert leading zeros 
	   i=i+1
	 enddo
	 if (DCL) then
	  do while (s_delta(i:i).ne.' ')
	   i=i+1
	  enddo
	  s_delta(i:i) = '-'  ! replace ' ' by '-' for DCL syntax
	 endif
	endif
	call EXIT(LIB$SET_SYMBOL(symbol(1:lls),s_delta(1:ll1)))
	END
