      OPTIONS /EXTEND_SOURCE
      PROGRAM FID2NAME
C
C=========================================
C
C   Purpose   : get file name from known File-ID (f,s,v)
C   Inputs    : DCL foreign command line
C          FID2NAME/SYMBOL=symbol disk/FID=(f,s,v)
C          default disk is SYS$DISK:
C          default symbol is FILE_NAME
C
C        Copyright (C) 2006   Joseph Huber (huber@mppmu.mpg.de)

C This program is free software; you can redistribute it and/or modify
C it under the terms of the GNU General Public License as published by
C the Free Software Foundation; either version 2 of the License, or
C (at your option) any later version.
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      INCLUDE '($libdef)'
      INCLUDE '($SSdef)'
      INCLUDE '($STSDEF)'
      INCLUDE '($IOdef)'
      INCLUDE '(LIB$ROUTINES)'
      INCLUDE '(STR$ROUTINES)'
      INCLUDE '($CLIDEF)'
      INCLUDE '(CLI$routines)'

      CHARACTER*4096 name
      CHARACTER*48 disk
      CHARACTER*32 symbol
      INTEGER i,code,iostat
      INTEGER*2 chan,ll,lld,lln,lls
      integer*2 FID(3)
      
      integer fid2name_table
      external fid2name_table
      integer fid_to_name
      external fid_to_name
      integer iostat_to_status
      external iostat_to_status
      integer init_cli_for
      external init_cli_for
      integer sys$assign
      external CLI$_NEGATED
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      ll = 0
      code = init_cli_for(fid2name_table,'FID2NAME')
      IF (.NOT.code) CALL exit(code)

      IF (cli$present('HELP')) THEN
       PRINT *,' FID2NAME[/SYMBOL=sym][/LOG] [disk:]/FID=(f,s,v)'
       PRINT *,' Puts the name of the file given by file-ID FID'
       PRINT *,' into DCL symbol specified by sym.'
       PRINT *,' Default symbol is FILE_NAME.'
       PRINT *,' Default disk is SYS$DISK: .'
       PRINT *,' /LOG: write resulting filespec to SYS$OUTPUT.'
       Call Exit(1)
      ENDIF

      disk='SYS$DISK:'
      IF (cli$present('P1')) THEN
         code=cli$get_value('P1',disk,lld)
      ENDIF
      call str$trim(disk,disk,lld)

      symbol = 'FILE_NAME'
      IF (cli$present('SYMBOL')) THEN
        code=cli$get_value('SYMBOL',symbol,lls)
      ENDIF
      call str$trim(symbol,symbol,lls)

      FID(1)=0
      FID(2)=0
      FID(3)=0

      IF (cli$present('FID')) THEN
        code=1
        i=1
        DO WHILE (code.AND.(i.LE.3))
         code=cli$get_value('FID',name,ll)
         IF (code) READ(name(1:ll),'(I)',err=8000,iostat=iostat) FID(i)
         i=i+1
        END DO
      ENDIF
D     print *,' FID=',FID
      code = LIB$fid_to_name(disk,FID,name,lln)
      if (code) then
       code = lib$set_symbol(symbol(1:lls),name(1:lln))
       i=CLI$PRESENT('LOG')
       IF (i.and.(i.ne.%LOC(CLI$_NEGATED))) then
        call LIB$PUT_OUTPUT(name(1:lln))
       endif
      endif
      CALL exit(code)

8000  Call exit(iostat_to_status(iostat))
      END
