      OPTIONS /EXTEND_SOURCE
      PROGRAM INVERT_ENDIAN
*<title>Convert files containing (binary) 32 bit integers to big-endian or vice versa</title>
C
C-----------------------------------------
C
C   Author   :- J.Huber                7-OCT-1997
C
C=========================================
C
C   Purpose   : convert calibration data file to OS9 (big-endian) format
C       in general, it converts any file, assuming the contents are binary
C       integer*4 words.
C   Inputs    : p1 = input file name
C   Outputs   :
C
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE

      INCLUDE '($RMSDEF)'
      INCLUDE '($LIBDEF)'
      INCLUDE '($CLIDEF)'
      INCLUDE '($STSDEF)'
      INCLUDE '($SSDEF)'
      INCLUDE '(LIB$ROUTINES)'
      INCLUDE '(STR$ROUTINES)'
      INCLUDE '(CLI$routines)'
      INTEGER status

      CHARACTER*240 dclline
      CHARACTER*80 ifilename
      CHARACTER*80 ofilename
      CHARACTER*80 p1
      CHARACTER*10 default
      CHARACTER*10 suffix

      integer*2 ll
      INTEGER L,Li,Lo
      INTEGER st
      LOGICAL logit

      INTEGER buf(8192/4)

      include 'RABADR.INC'

      INTEGER find_file
      EXTERNAL find_file
      INTEGER BIO_READ,BIO_WRITE
      EXTERNAL BIO_READ,BIO_WRITE
      INTEGER BIO_OPEN,BIO_OPENW
      EXTERNAL BIO_OPEN,BIO_OPENW

      integer CLI$_NEGATED
      external CLI$_NEGATED
      integer invert_cli_table
      external invert_cli_table

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      logit = .FALSE.    !could be made variable by commandline /qualifiers
      default = '.DSP'
      suffix = '_INVERTED'
      st = LIB$get_foreign(dclline,'Convert file:',li)
      IF (.NOT.st) THEN
        CALL LIB$put_output('No commandline given')
        CALL exit(st)
      ENDIF
      IF (li .LE. 0) THEN
        CALL LIB$put_output('No filename given in commandline')
        CALL exit(0)
      ENDIF


      status = cli$dcl_parse('INVERT '//dclline,invert_cli_table,
     &  lib$get_input,lib$get_input,'Filename')
      IF (.NOT.status) Then
        call lib$put_output
     &    (' Commandline syntex error from cli$dcl_parse')
        CALL exit(status)
        endif
      status = cli$present('LOG')
      IF (status.and.(status.ne.%LOC(CLI$_NEGATED))) logit=.TRUE.
      status=1
      st = 1
      IF (cli$present('P1')) THEN
      DO WHILE  (cli$get_value('P1',p1,ll))
D      if (logit) call lib$put_output(' CLI P1: '//p1(1:ll))
      DO WHILE (st)
        st = find_file(p1,default,ifilename)
        IF (st) THEN
          CALL str$trim(ifilename,ifilename,li)
          if (logit) call lib$put_output(' Inverting file: '//p1(1:ll))
          L = str$find_first_in_set(ifilename,';')
          IF ((l.GT.0) .AND. (l.LE.li)) li=l-1
          IF (logit) THEN
            CALL lib$put_output('Input file:'//ifilename(1:li))
          ENDIF
          ofilename = ifilename(1:li)//suffix
          lo = li+LEN(suffix)
          IF (logit) THEN
            CALL lib$put_output('Output file:'//ofilename(1:lo))
          ENDIF
          OPEN(unit=1,name=ifilename,
     1      iostat=st,status='OLD',READONLY,
     4      useropen=BIO_OPEN)

          IF (st .EQ. 0) THEN
            OPEN(unit=2,name=ofilename,
     1        iostat=st,status='NEW',
     2        access='DIRECT',recordtype='FIXED',
     3        organization='SEQUENTIAL',recl=128,
     4        useropen=BIO_OPENW)
            IF (st .EQ. 0) THEN
              L = 8192
              DO WHILE(L .GT. 0)
                L = 8192
                st = BIO_READ(%val(RABADR(1)),Buf,L)
                IF (st) THEN
                  CALL VXINVB(buf,L/4)
                  st = BIO_WRITE(%val(RABADR(2)),Buf,L)
                  IF (.NOT.st) THEN
                    CALL LIB$put_output('Write error on '//ofilename(1:
     &                lo))
                  ENDIF
                ENDIF
              ENDDO
              CLOSE(unit=1)
              CLOSE(unit=2)
              
            ELSE
              CALL lib$put_output('Failed to open file '//ofilename(1:
     &          lo))
            ENDIF
          ELSE
            CALL lib$put_output('Failed to open file '//ifilename(1:li))
          ENDIF
          st = 1
        ENDIF
      ENDDO !while find_file
      st = 1
      ENDDO !while cli$get_value('p1'
      ENDIF !cli$present('p1')
      END
