	Program MSP
*+
*	MSP.FOR
*
*<title>Utility to position unmounted/unlabelled tapes</title>
*	Operates on tape defined by logical name $TAPE1
*
*       Call it by a DCL commandline:
*
*       MSP command [par1 [par2 ... [parN]]]
*
*       Commands are:
*       RW or REwind   rewind to BOT
*       AP             position to end of last file for append
*       NEW            position behind last file on volume for next file
*       POS nf[:nb]    position to file nf, block nb (nf,nb=1,2,....)
*       EOF            write EOF at current tape position
*       SEnse          sense characteristic (return ch. in exstat)
*       CB             count blocks to next EOF (return # in exstat)
*       UN             rewind and unload tape
*	MOVE nf[:nb]   move <nf> files forward (nf>0) or backwards (nf<0)
*		       and optional nb blocks after file positioning
*	DEnsity n      set density n (=800,1600,6250,833)
*       RBblock n      Read n Blocks from current position
*
*	The calling process must have the log_io privilege or the
*	tape must be mounted /FOREIGN (the normal case).
*-
*	Author: J.Huber, MPI Muenchen
*	Creation date: April'88
*	Revision date: 7-July-88

      Implicit NONE
	Integer Ncmd,dimjx
	Parameter (NCMD=12)	!number of commands
	Parameter (dimjx=10)	!possible number of parameters



	Character*80 cml_string
	Character*78 arg_string
	Character*2 word,xword
	DIMENSION XWORD(ncmd)
	Integer i,len,icmd,ns,ids
	Integer chan,state,newpos,newblk
	Integer*2 iostat(2)
	Integer IOSB(2),jx(dimjx)
	Equivalence (iosb(1),iostat(1))
      Integer count,nprm
	Logical Status,first_call

	Integer getcml	!library routine
	Logical MT$assign,MT$sense,MT$spb,MT$spf,MT$open,MT$append
      Logical MT$block_io,MT$density

	Include 'MTsense.inc'

      integer*2 buffer(16384)
      common /buffer/ buffer

	Data first_call/.TRUE./

Command - loop starts at 5

5	CONTINUE

C	get commandline
	word = '    '
	len = getcml(cml_string,' MSP>')
	if (len) 6,5,7
6	CONTINUE

9999	CALL EXIT(state)

7	continue

	if (LEN.le.0) go to 5		!end of line
	nprm = 0		!assume no arguments
*	reset parameter array
	do 3011 i=1,dimjx
3011	jx(i) = 0		!zero argument list 

	NS=1
*	Extract 2 character command verb
	Call STR$LEFT(word,cml_string,2)
	NS = Index(cml_string,' ')
	If (NS.gt.0) Then
	 len = len-NS
	 NS = NS+1	!point to parameters
*	 Remaining commandline containing parameters
*	 Extract parameter string
	 Call STR$RIGHT(arg_string,cml_string,NS)
	 IF (len.gt.0) Then
c	  parse free format string into I*4/R*4 array Jx:
	  call Fparse (len,arg_string,dimjx,jx,nprm,ids)
	 Endif
	Endif

*	interpret command <word> <arg_string>
*	search in command-table for a command-verb match:
*	as long as the table is not so big a simple linear search is enough

 2006	DO 3005 Icmd=1,NCMD
	IF(WORD.EQ.XWORD(Icmd)) GO TO 3010	!this command ?
3005	CONTINUE
3006	TYPE 6910, cml_string
6910	FORMAT(' MSP ? ',A/' Use HELP to get a list of commands')
	GO TO 5		!execute HELP command
 3010	continue

D	Type *, ' Command: ',word,' nprm=',nprm
D	Type *, ' Parms:',(jx(i),i=1,nprm)


	If (first_call) Then
	 Status = MT$assign('$TAPE1:',chan,0,iosb,'S')
	 If (.not.status) Call Exit(Status)
	 first_call = .false.
	Endif

	DATA XWORD/
     &	'RW','AP','NE','PO','EO','SE','CB','UN',
     &'MO','RE','DE','RB'/

*	dispatch according to command verb
	GO TO (
     & 100,200,300,400,500,600,700,800,900,100,910,920), Icmd

90	Continue
	state = iosb(1)
91	Continue

D	type 5090 , state,status,iosb,sense_buffer
D5090	Format(' State=',Z8,' status=',Z8/' IOSB=',2Z9/' sense:',3Z9)
	go to 5

100	CONTINUE	!rewind tape
	Call MT$Rewind(chan,iosb,.False.)
	Go to 610
200	CONTINUE	!position tape for file append
	Status = MT$append(chan,iosb)
	Go to 90
300	CONTINUE	!open new file  (at end of volume)
	Status = MT$open(chan,iosb)
	Go to 90
400	CONTINUE	!Position
	Call MT$Rewind(chan,iosb,.False.)
	Newpos = Max(0,JX(1)-1)
	If (Newpos.gt.0) Then
	 Status = MT$SPF(chan,newpos,iosb)
	Endif
	Newpos = Max(0,JX(2)-1)
	If (Newpos.gt.0) Then
	 Status = MT$SPB(chan,newpos,iosb)
	Endif
*	 return file number starting at 1
	iostat(2) = iostat(2)+1
	Go to 90
500	CONTINUE	!EOF
	Call MT$close(chan,iosb)
	Go to 610
600	CONTINUE	!Sense
610	Continue
	Status = MT$sense(chan,iosb)
	State = iosb(2)
	Go to 91
700	CONTINUE	!CB
	newblk = 0
	status = .true.
	Do While (status)
	 status = MT$spb(chan,1,iosb)
	 If (Status) newblk = newblk+1
	Enddo
	iostat(2) = newblk
	Go to 90
800	CONTINUE	!UN
	Call MT$unload(chan,iosb,.FALSE.)
	GO TO 610	
900	Continue	!MOve
	Status = 0
	If (jx(1).ne.0) Status = MT$SPF(chan,jx(1),iosb)
	If (jx(2).ne.0) Status = MT$SPB(chan,jx(2),iosb)
	Goto 90	
910	Continue	!DEnsity
	Status = 0
	If (jx(1).gt.0) Status = MT$DENSITY(chan,iosb,jx(1))
	Goto 90	
*
*          COND = MT$BLOCK_IO (CHAN,LENGTH, BLOCK, IOSB,FUN,SWAP)
*
*               LENGTH = length to be written/buffer size for read
*               BLOCK =  block buffer of at least <BLOCKLENGTH> bytes
*               FUN =    -1 for read   +1 for write
*               SWAP=1  ----> swap bytes (for conversion IBM->DEC)
*

920	CONTINUE	!RB
	status = .true.
      newblk = 0
	Do while (status)
      count = 32768
	status = MT$block_io(chan,count,buffer,iosb,-1,0)
      newblk = newblk+1
	iostat(2) = newblk
      if (newblk.ge.jx(1)) status = 0
	Enddo
      if (status.eq. 0) status = iostat(1)
	Go to 90
	END
