/* <TITLE> Translates a Unix path to an OpenVMS directory spec </TITLE> */
/* 
   original vms_to_unix:
   19-JUN-2000, David Mathog, Biology Division, Caltech

   2002-02-28 J.Huber to do the inverse unix-to-vms

   Translates a Unix path to an OpenVMS directory spec .  
   stored in the symbol VMS_DIRECTORY
   Otherwise the symbol is left empty (for no translations) .

   This is a version of UNIX_TO_VMS forcing directory syntax.
   ==========================================================
   i.e. even if the argument is a file, it translates to a directory,
    e.g. file.dat -> [.file^.dat] .

   The translation policies are up to CRTL routine DECC$to_vms,
   it depends on the C RTL library version, and eventually from DECC features 
   like 
  DEFINE DECC$DISABLE_TO_VMS_LOGNAME_TRANSLATION "ENABLE"
  translates foo/bar to [.foo.bar], otherwise to foo:[bar] .


*/
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <descrip.h>
#include <unixlib.h>
#include <unixio.h>
#include <string.h>
#include <lib$routines.h>

#define MAXFILENAME 4096
static char symbol_value[MAXFILENAME];  
static struct  dsc$descriptor_s  symbol_value_desc;

static char vfilename[MAXFILENAME];
static char *res;

int emit(char *string, int dummy){
char *slide;
char *lastdot;
   strcpy(symbol_value,string); 
   fprintf(stdout,"%s\n",string);
   return(1);
}

int main(int argc, char *argv[]){
 int temp;

 $DESCRIPTOR (symbol_name_desc,"VMS_DIRECTORY");

  symbol_value_desc.dsc$b_class =  DSC$K_CLASS_S;
  symbol_value_desc.dsc$b_dtype =  DSC$K_DTYPE_T;

  symbol_value[0]='\0';
  switch(argc){
     case 2:
        if(*argv[1] == '\0'){
           argv[1]=".";
        }
        (void) decc$to_vms(argv[1], emit, 0, 2); /* nowild,force dir */
        break;
     default:
        (void) fprintf(stderr,
"\n usage: \n\n  path_to_directory path \n\n");        
        (void) fprintf(stderr,
"  path is any valid Unix directory name \n");        
        (void) fprintf(stderr,
"    Only names for extant directories will be translated\n");
  }
  symbol_value_desc.dsc$w_length = strlen(symbol_value);
  symbol_value_desc.dsc$a_pointer =  symbol_value;
  (void) LIB$SET_SYMBOL(&symbol_name_desc,&symbol_value_desc);
}
