      OPTIONS /EXTEND_SOURCE
      PROGRAM RDMBX
C
C-----------------------------------------
C
C   Author   :- J.Huber               30-AUG-1990
C   Modified :- J.Huber               23-MAY-1992
C   Modified :- J.Huber               20-SEP-1992
C   Modified :- J.Huber               15-AUG-1993  add 2nd cml parameter symbol
C   Modified :- J.Huber               2006  add 3rd parameter Wait
C
C=========================================
C
C   Purpose   :<title>read a message from a mailbox into a DCL symbol</title>
C   Inputs    :DCL commandline
C   Outputs   :status code
C
* DCL foreign command syntax:
*        RDMBX <mail_box_name> [ dcl-symbol-to-return ] [Wait]
* If called without a commandline, RDMBX will prompt for mail_box_name.
* (mail-box-name may be a logical name or the physical device MBAn:).
* The message received from the Mailbox is put into DCL symbol specified
* (default symbol is MBXCMD).
* if 3rd command parameter is "W", then read waits for data available, else 
* rdmbx returns immediately if mailbox is empty.
* Attention: DCL symbol is only set on successfull (>0 characters) mbx read
*            Check for $STATUS and use if f$type(mbxcmd) .nes. "" before use.
**Libraries needed:
*  UTIL/LIB: GET_TOKEN
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      INCLUDE '($SSDEF)'
      INCLUDE '($IODEF)'
      INTEGER LIB$GET_FOREIGN,get_token
      INTEGER*2 lout
      INTEGER*2 chan
      Integer SYS$ASSIGN,cond
      INTEGER SYS$QIOW
      CHARACTER*80 buf
      CHARACTER*48 mbx,mbxcmd
      Character*4 waitbuf
      INTEGER*2 iosb(4),lc2
      Logical dowait

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      dowait=.FALSE.
!      lout = getcml(buf,'Mail_box_name:')
      cond = LIB$GET_FOREIGN(buf,'Mail_box_name:',lout)
      if (.NOT.cond) call exit(cond)
      cond = 0
      IF (lout.GE.0) THEN
        lout = get_token(buf,mbx) !get mbx device name
        IF (lout.GE.0) THEN
          CALL STR$trim(mbx,mbx,lc2)
          IF (lc2.GT.0) THEN !need a device name
*        assign mailboxes to server processes
            Cond = SYS$ASSIGN (mbx(1:lc2),chan,,)
            IF (cond) THEN
              lout = get_token(buf,mbxcmd)  !extract DCL symbol name from cml
              lout = get_token(buf,waitbuf)  !extract Wait flag from cml
              if (waitbuf(1:1).eq.'W'.or.waitbuf(1:1).eq.'w') dowait=.TRUE.
              lout=80
              IF (dowait) THEN
               Cond = SYS$QIOW(
     &           ,%VAL(chan),%VAL(IO$_READVBLK),iosb,,,
     &           %ref(buf),%val(lout),,,,)
              ELSE
               Cond = SYS$QIOW(
     &           ,%VAL(chan),%VAL(IO$_READVBLK.OR.IO$M_NOW),iosb,,,
     &           %ref(buf),%val(lout),,,,)
              ENDIF
              CALL sys$dassgn(%VAL(chan))
              IF (cond) THEN
                cond = iosb(1)
                lout = iosb(2)
                CALL STR$trim(mbxcmd,mbxcmd,lc2)
                IF (lc2.LE.0) THEN
                  mbxcmd = 'MBXCMD'
                  lc2 = 6
                ENDIF
                CALL LIB$SET_SYMBOL(MBXCMD(1:lc2),buf(1:lout))
              ENDIF
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      CALL exit(cond)

      END
