      PROGRAM TASTE
C
C-----------------------------------------
C
C   Author   : Joseph Huber               28-SEP-1992
C
C  After an original idea published in DECKBLATT 10/1992
C  (Author: J.Fink, GPP mbH)
C=========================================
C
C   Purpose   : <title>Get a single Keystroke from keyboard</title>
C               Put the corresponding keycode into a DCL symbol
C   Inputs    : DCL commandline p1=DCL symbol name, [p2=prompt string]
C        optional command /Options:
C         /TIMEout=nsec   : timeout in seconds
C         /HEXA           : return key hexdecimal
C         /TEXT           : return key as symbolic name
C   Outputs   : DCL symbol set to the code returned by smg$read_keystroke:
C               SMG$K_TRM_x in $SMGDEF (of forsysdef.tlb) .
C
C Program exit status is that of the smg$read_keystroke.
C In case of timeout the symbol is "TIMEOUT", and exit status is success.
C Any non-success is either a CLI or conversion error.
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
	external TASTE_TABLE

        Include '($SSDEF)'
        Include '($SYSSRVNAM)'
	INCLUDE '($CLIDEF)'
	INCLUDE '(CLI$routines)'
	INCLUDE '(LIB$ROUTINES)'
	INCLUDE '(SMG$ROUTINES)'
        INCLUDE '($SMGDEF)'
	INCLUDE '($LIBDEF)'
        INCLUDE '($DSCDEF)'


      Integer OTS$CVT_TI_L
      External OTS$CVT_TI_L
      INTEGER*2 ll
      INTEGER status,keyboard_id,tastencode
      CHARACTER*40 prompt,symbol,line
      CHARACTER*16 tastensymbol
      Integer timeout
      logical astext,ashexa

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C set defaults:
        
        timeout=0
        astext=.false.
        ashexa=.false.
        tastensymbol='TASTE'

        status=0
	call init_cli_for(TASTE_TABLE,'TASTE')

	if (cli$present('HELP')) then
 	 Print *,' TASTE[/TIMEOUT=sec/HEXA/TEXT] symbol prompt '
	 Print *,' Returns in symbol a single keystroke from sys$command'
	 Call Exit(1)
	endif

      If (cli$present('hexa')) ashexa=.true.
      If (cli$present('text')) astext=.true.
      If (cli$present('timeout')) Then
      status=cli$get_value('TIMEOUT',line,ll)
      if (status) then
        status = OTS$CVT_TI_L(line(1:ll),timeout)
      endif 
      if (.not.status) call exit(status)
      Endif 

      status = cli$get_value('prompt',prompt,ll)
      IF (.not.status) THEN
	prompt=char(0)
	ll = 0;
      ENDIF
      status = cli$get_value('symbol',symbol)
        IF (status) THEN
          status = smg$create_virtual_keyboard(keyboard_id)
          IF (status) THEN
           if (ll.eq.0) then
            if (timeout.le.0) then
             status=smg$read_keystroke(keyboard_id,tastencode)
            else
             status=smg$read_keystroke(keyboard_id,tastencode,
     &                      ,timeout)
            endif
           else
            if (timeout.le.0) then
             status=smg$read_keystroke(keyboard_id,tastencode,
     &                                prompt(1:ll))
            else
             status=smg$read_keystroke(keyboard_id,tastencode,
     &                      prompt(1:ll),timeout)
            endif
           endif
         IF (status) THEN
          if (ashexa) then 
           CALL OTS$cvt_L_TZ(tastencode,tastensymbol) !hexadecimal symbol
          else if (astext) then 
           status = SMG$KEYCODE_TO_NAME(tastencode,tastensymbol) ! key name
          else
           CALL OTS$cvt_L_TI(tastencode,tastensymbol)  !decimal symbol
          endif
         ELSE
          if (status.eq.SS$_TIMEOUT) then
            tastensymbol='TIMEOUT'
            status=SS$_NORMAL
          endif
         ENDIF
        ENDIF
      ENDIF
      if (status) then
       call str$trim(tastensymbol,tastensymbol,ll)
       status=lib$set_symbol(symbol,tastensymbol(1:ll))
      endif
      Call EXIT(status)
      END
