      PROGRAM UUTrim
*++
* Created: 31-jul-1990 J.Huber
*<title>cut files between "begin" and "end" for uudecode</title>
* UUTrim reads a input-file and writes a new output file
* with the same content, everything before a "begin " line, and following a
* "end" line removed.
*
** usage:
* if defined as a DCL foreign command:
*        UUTrim <filespec>
* will produce a new version of the file <filespec>.
* If called without a commandline, UUTrim will prompt for the input
* file on sys$input.
*
**Libraries needed:
*  $$HUBER:[UTIL]UTIL/LIB
*--
      IMPLICIT NONE
      CHARACTER*80 cardin
      INTEGER*2 lout
      CHARACTER*45 file
      INTEGER getcml
      LOGICAL dosave

      lout = getcml(file,'Input file_spec:')
      IF (lout.GE.0) THEN
        OPEN(unit=1,name=file,type='OLD',readonly,err=899)
        OPEN(unit=2,name=file,type='NEW',carriagecontrol='LIST',
     &          err=898)

        dosave = .false.
        DO WHILE (.true.)
          READ(1,1000,end=999) cardin
          CALL str$trim(cardin,cardin,lout)
          IF (cardin(1:6).EQ.'begin ') THEN
            dosave = .true.
            call lib$put_output(cardin)
          ENDIF
          IF (lout.GT.0 .AND. dosave) THEN
            WRITE(2,2000) cardin(1:lout)
          ENDIF
          IF (cardin(1:3).EQ.'end') THEN
            dosave = .false.
            call lib$put_output(cardin)
          ENDIF
        ENDDO

  999   CLOSE(unit=2)
      ENDIF

      CALL exit(1)
  898 CALL lib$put_output('Failed to open output-file: '//file)
      CALL exit(0)
  899 CALL lib$put_output('Failed to open input-file: '//file)
      CALL exit(0)

 1000 FORMAT(a80)
 2000 FORMAT(a<lout>)
      END
