!<TITLE>wake.for: WAKE a process by name or identification </TITLE>
! Author: Joseph Huber
C        Copyright (C) 2005   Joseph Huber (huber@mppmu.mpg.de)

C        This program is free software; you can redistribute it and/or modify
C        it under the terms of the GNU General Public License as published by
C        the Free Software Foundation; either version 2 of the License, or
C        (at your option) any later version.

C        This program is distributed in the hope that it will be useful,
C        but WITHOUT ANY WARRANTY; without even the implied warranty of
C        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C        GNU General Public License for more details.



! DCL syntax:
! WAKE[/qualifier] process
!  p1 = process name
! /IDENTIFICATION=hexpid   process ID (hexadecimal)
! /NODE=nodename            only processes on given node 
! /USER=username            only processes of given username
! /LOG                      log process data to sys$output
! /HELP : display description

	Program WAKE

        Implicit NONE

        Include '($SYSSRVNAM)'
        Include '($SSDEF)'
	INCLUDE '($CLIDEF)'
	INCLUDE '($CLIMSGDEF)'
	INCLUDE '(CLI$routines)'
	INCLUDE '(LIB$ROUTINES)'
	INCLUDE '($LIBDEF)'

	character*16 s_hex

	character*32 search_name,search_user,search_node
	character*32 name,user,node
	character*255 image

	integer*4 ident
	integer status,ctx
	integer*2 snal,snol,sul,hexl
	integer*2 nal,nol,ul
	logical dolog

	integer process_scan
	EXTERNAL process_scan
	EXTERNAL WAKE_TABLE

	ident=0
	dolog=.false.
	search_name=' '
	search_node='*'
	search_user='*'
	snal=1
	snol=1
	sul=1

	call init_cli_for(WAKE_TABLE,'WAKE')

	if (cli$present('HELP')) then
	Print *,' WAKE process'
	Print *,' Wakes a hibernated process given by name or PID'
	Print *,' /IDENT=hexadecimal process ID instead of name'
	Print *,' /NODE=nodename  processes on node only'
	Print *,' /USER=username  processes of user only'
	Print *,' /LOG            log process data to sys$output'
	Call Exit(1)
	endif

      IF (cli$present('P1')) THEN
        status=cli$get_value('P1',search_name,snal)
      ENDIF
      IF (cli$present('NODE')) THEN
        status=cli$get_value('NODE',search_node,snol)
      ENDIF
      status = cli$present('LOG')
      IF (status .and. (status.ne.CLI$_NEGATED)) THEN
        dolog=.TRUE.
      ENDIF
      IF (cli$present('USER')) THEN
        status=cli$get_value('USER',search_user,sul)
      ENDIF
      status=cli$present('IDENTIFICATION')
      IF (status.eq.CLI$_PRESENT) THEN
        status=cli$get_value('IDENTIFICATION',s_hex,hexl)
        read(s_hex(:hexl),'(Z)') , ident
      ENDIF
      IF (ident.ne.0 .or. search_name(:snal).eq.' ') Then
        if (dolog) print 1000 , ident
        call exit(sys$wake(ident,%VAL(0)))
      ENDIF

      if (dolog) print *, ' Searching for process ',search_name

	status=1
	ctx=0
	DO while (status)
	 status=process_scan(ctx,ident,
     &	   search_node(:snol),search_user(:sul),
     &     node,user,name,image)
	 if (status) then
	   call str$trim(node,node,nol)
	   call str$trim(name,name,nal)
	   call str$trim(user,user,ul)
	   if (search_name(:snal).eq.name(:snal)) then
	     if (dolog) print 1001 , ident,node(:nol),user(:ul),name(:nal)
	     status=sys$wake(ident,%VAL(0))
	   endif
	 endif
	endDo

*	if (status.eq.'09A8'X) status=1
	if (status.eq.SS$_NOMOREPROC) status=SS$_NORMAL
	call exit(status)

1000    format(' WAKE for process ID ',Z8.8)
1001    format(' WAKE for process ID ',Z8.8,1X,A,'::',A,':',A)

	END


!	     if (.not.status) call LOGSYSMESSAGE(status)
!      SUBROUTINE LOGSYSMESSAGE(code)
C   Purpose   : type the full-text message for a VMS system condition code
C   Inputs    : long code , by reference
C   Outputs   : message typed to sys$output
!      IMPLICIT NONE
!      INTEGER code
!      CHARACTER*256 message
!      integer*2 msglen
!      CALL LIB$SYS_GETMSG(code,,message)
!      call STR$TRIM(message,message,msglen)
!      call lib$put_output(message(1:msglen))
!      END
