!++
!     Define symbols according to macro values
!--

.IFDEF DEBUG
DBG = /DEBUG
DBGOPT = /NOOPTIMIZE/DEBUG
.ELSE
DBG = /NODEBUG
DBGOPT = /OPTIMIZE/NODEBUG
.ENDIF

.IFDEF LIST
LST = /LIST
.ELSE
LST = /NOLIST
.ENDIF

.IFDEF DIAG
DIA = /DIAGNOSTICS
.ELSE
DIA = /NODIAGNOSTICS
.ENDIF

.IFDEF PCA
PCAOPT = /DEBUG
.ENDIF


.IFDEF __VAX__
TIE =
NATIVE =
FFLAGS = /INCLUDE=([],[-],[-.INCLUDE],SYS$LIBRARY:)
.ELSE
TIE = /TIE
NATIVE = /NONATIVE
FFLAGS = /INCLUDE=([],[-],[-.INCLUDE],SYS$LIBRARY:)
.ENDIF

LINKLIB = SYS$LIBRARY:UTIL/LIB

CFLAGS = /INCLUDE=(SYS$LIBRARY:)

.SUFFIXES : .exe .obj .c .h .for .f90 .f .inc .mar .cld .uil .uid

.c.obj :
        $(CC) $(CFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.for.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.f90.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.f.obj :
        $(FORT) $(FFLAGS) $(LST) $(DBGOPT) $(DIA) $<

.mar.obj :
        $(MACRO) $(LST) $(DBGOPT) $(DIA) $<

.cld.obj :
       SET COMMAND/OBJECT $<

.uil.uid :
       UIL $<

.obj.exe :
       LINK $(DBG) $(PCAOPT)  $<,$(LINKLIB)


!++
!     Missing sources catch-all
!--

.DEFAULT
   ! No source found for $(MMS$TARGET)
   ! - Attempting to continue

!++
!   Complete application - default build item
!--

COMPLETE_APPLICATION depends_on -
     WAKE.EXE 
        CONTINUE


!++
!   Object files
!--


WAKE.OBJ depends_on -
      WAKE.FOR -
     !
       $(FORT) $(FFLAGS)  $(LST) $(DBGOPT) $(DIA) $(TIE) /OBJ=WAKE.OBJ WAKE.FOR

FILL_ITMLST.OBJ depends_on -
      [-]FILL_ITMLST.FOR -
     !
 $(FORT) $(FFLAGS)  $(LST) $(DBGOPT) $(DIA) $(TIE) /OBJ=FILL_ITMLST.OBJ [-]FILL_ITMLST.FOR

PROCESS_SCAN.OBJ depends_on -
      [-]PROCESS_SCAN.FOR -
     !
 $(FORT) $(FFLAGS)  $(LST) $(DBGOPT) $(DIA) $(TIE) /OBJ=PROCESS_SCAN.OBJ [-]PROCESS_SCAN.FOR

init_cli_for.OBJ depends_on [-]init_cli_for.for -
     !
 $(FORT) $(FFLAGS)  $(LST) $(DBGOPT) $(DIA) /OBJ=init_cli_for.OBJ [-]init_cli_for.for

!++
!  DCL tables
!--


WAKE_TABLE.OBJ depends_on WAKE_TABLE.CLD -
      !
      SET COMMAND/OBJ WAKE_TABLE.cld


!++
!   executable
!--

 
WAKE.EXE depends_on -
      WAKE.OBJ WAKE_TABLE.OBJ init_cli_for.OBJ fill_itmlst.OBJ process_scan.OBJ 
     !
       LINK $(DBG) $(PCAOPT) $(NATIVE) /EXE=WAKE.EXE WAKE,WAKE_TABLE,init_cli_for,-
fill_itmlst,process_scan
          ! End of Link WAKE
 
     
.FIRST:
       ! MMS begins
.LAST:
       ! MMS Done

