/*
 <head><META name="keywords" content="string,descriptor,VMS">
 <title>  make a descriptor for a fixed-length string </title><pre>

      SUBROUTINE MAKE_DSC_STR(STRING,LENGTH,DSC)

 
   Author   :- J.Huber                3-MAR-1991

   Purpose   : make a descriptor for a fixed-length string
   Inputs    : 
       STRING by reference : address of the (character-)string
       LENGTH by reference : length of the (character-)string
   Outputs   : 
       DSC    by reference : descriptor for the string

   Usage example:
   SUBROUTINE Handle_C_string(string,length)
   INTEGER length
   BYTE string(length)
   INCLUDE '($DSCDEF)'
   RECORD /DSCDEF1/ dsc
   CALL MAKE_DSC_STR(string,length,dsc)
   CALL LIB$PUT_OUTPUT(dsc)
   Typically such a call is needed where a string is passed from a C program
   to a Fortran routine.
*/

#include stddef
#include string
#include descrip

  void make_dsc_str(char *string,short *length,struct dsc$descriptor *dsc) 
     {

      if (length == NULL) {dsc->dsc$w_length = strlen(string);} 
      else {dsc->dsc$w_length = *length;}
      dsc->dsc$b_dtype  = DSC$K_DTYPE_T;
      dsc->dsc$b_class  = DSC$K_CLASS_S;
      dsc->dsc$a_pointer = string;
      }
