/* 
        MOVE_DATA.C
<html><head>
<title>  moving data from source to destination. </title></head><body><pre>
   		users takes care that destination buffer is big enough.
   		routine is using LIB$MOVC3 call.
   	Parameters:
   		length 		- number of bytes to be moved from source to destination;
   				 	  access: pointer to integer;
   		source 		- item to be moved.
   				 	  access: pointer to an item;
   		destination - item to which source will be moved;
   					  access : pointer to an item.
   
         Created           : 20-SEP-1991 by Elzbieta Banas
    Modified: 9-Oct-2000  to be used on systems other than VMS
*/
 
#ifdef VMS_ONLY 
#define MAX_BUF 65535
#include <lib$routines.h>
#else
#include <string.h>
#endif

move_data (length, source, destination)
int  *length;
char *source;
char *destination;

{
#ifdef VMS_ONLY
	int item = 0, fixed, bytes;
	fixed = MAX_BUF;
	while (*length > MAX_BUF)  {
		LIB$MOVC3 (&fixed, source, destination);
		*length -= MAX_BUF; source+=MAX_BUF; destination+=MAX_BUF;
	}
	if (*length>0)
		LIB$MOVC3 (length, source, destination);
#else
   memmove(destination,source,*length);
#endif
	return (0);
	
}

#ifdef TEST
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>                   /* I/O definitions                       */
main ()

{
	int buforek_1[40000];
	int buforek_2[40000];
	int len=160000, i;
	
	for (i=1; i<len/4; i++) {
		buforek_1[i] = i;
		buforek_2[i] = 0;
	}
	
	move_data (&len, buforek_1, buforek_2);
	
	for (i=0; i<len/4; i++) 
		if (buforek_1[i] != buforek_2[i]) {
			printf ("Blad : i-%d, buf2-%d\n", i, buforek_2[i]);
			exit (0);
		}
			
	printf ("BUFOREK\n");
	for(i=0; i<25; i++)
		printf (" %d ", buforek_2[i]);
	printf ("\n");
	
	exit (0);
}	
			
#endif
/*</pre></body></html>*/
