      INTEGER FUNCTION PADD_ZS(STRING,MAX_LEN)
C
C-----------------------------------------
C
C   Author   :- J.Huber               22-JAN-1991
C
C=========================================
C
C   Purpose   :<title> padds a NULL terminated character array with blanks, </title>
C               to ease interfacing C to Fortran.
C   Returned value  : length of non-blank portion of the string
C   Inputs    : STRING  : character array (passed by descriptor!)
C               MAX_LEN : maximum length or dimension of the array
C   Outputs   : STRING padded with blanks from first ascii nul to max_len
C
C   Usage note:
C   Since STRING is passed by descriptor, the standard VAX-Fortran mode
C   for characters, this routine is intended to be called from Fortran (or
C   other languages with standard VAX binding) programs, wich have to treat
C   string left in structures from C.
C   To handle strings passed by reference, different routine is needed ...
C   or use the FS function provided in VAX_UTILS to pass the string.
C===========================================================================
C +
C Declarations.
C -
      IMPLICIT NONE
      CHARACTER*(*) string
      INTEGER max_len

      INTEGER L
      CHARACTER NULL

C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      NULL = char(0)                
      DO L=1,max_len
        IF (string(L:L).eq.NULL) Then
          string(L:) = ' '                
          padd_zs = L-1
          RETURN
        ENDIF
      ENDDO
      padd_zs = max_len
      RETURN
      END
