      SUBROUTINE PARSE_OS9_FILE(OS9_file,path,name)
C
C-----------------------------------------
C
C   Author   :- J.Huber                6-APR-1991
C
C=========================================
C
C   Purpose   :
C   <title>    Parse an OS9-file-specification into path-name and pure file-name </title>
C       In the file name, characters illegal
C       in VMS file-names will be replaced "_", in particular, multiple
C       "." in file-types.
C   Returned value  : -
C   Inputs    :
C       character*(*) OS9_file
C   Outputs   :
C       character*(*) path : the OS9 path-name
C       character*(*) name : the pure,corrected file-name
C
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      INCLUDE '($STRDEF)'
      INCLUDE '(STR$ROUTINES)'

      CHARACTER*(*) OS9_file,path,name

      INTEGER L
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      L = 0
      CALL STR$trim(OS9_file,OS9_file,L)
      path = ' '
      name = ' '
      DO WHILE (L.GT.0)
        IF (OS9_file(L:L).NE.'/') THEN
          name = OS9_file(L:)
          L=L-1
        ELSE
          CALL STR$right(name,OS9_file,L+1)
          CALL STR$left(path,OS9_file,L)
          L = 0
        ENDIF
      ENDDO
*       if the OS9_file is only a device-name like '/h2', it would wrongly
*       parse into path='/' and name='h2': correct for that
      IF (path.EQ.'/') THEN
        path = '/'//name
        name = ' '
      ENDIF
*       replace multiple '.' by '_'
      l = STR$find_first_in_set(name,'.')
      IF (l.GT.0) THEN
        CALL STR$TRANSLATE(name(L+1:),name(L+1:),'_','.')
      ENDIF
      END
