      INTEGER FUNCTION PRINT_AND_DELETE( FILENAME, QUEUE, FORM, ENTRY )
C
C-----------------------------------------
C
C   Author   :- J.Huber               23-MAR-1994
C
C=========================================
C
C   INTEGER FUNCTION PRINT_AND_DELETE( FILENAME, [QUEUE], [FORM], [ENTRY] )
C   Purpose   : <title> print a file on queue , delete after printing </title>
C   Inputs    : character FILENAME by descriptor: filename       [no default]
C               character QUEUE by descriptor: name of queue     [PSLASER]
C               character FORM  by descriptor: form name         [POSTSCRIPT]
C
C the default queue = PSLASER is taken if the
C queue argument is specified as ' ' or missing.
C The default form is the form specified with the queue.
C
C   Outputs   : integer ENTRY : entry number of print job
C   Function return value: VMS condition code of $SNDJBCW system service
C
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE

      CHARACTER*(*) filename
      Integer queue,form
*!!* args queue and form are declared as BYTE, not CHARACTER to allow omitting
*!!* the argument to use the defaults. Since the arguments are just passed to
*!!* other calls, it works. If an argument would be omitted if declared as
*!!* character*(*), an access violation would occur !
      INTEGER ENTRY
      INTEGER print_and_keep

      INTEGER sys$sndjbcw
      EXTERNAL sys$sndjbcw
      INTEGER status
      INCLUDE '($SJCDEF)'
      STRUCTURE /itmlst/
        UNION
          MAP
            INTEGER*2 buflen,itmcod
            INTEGER*4 bufadr,retadr
          END MAP
          MAP
            INTEGER*4 end_list
          END MAP
        END UNION
      END STRUCTURE

      STRUCTURE /iosb/
        UNION
          MAP
            INTEGER*4 sts,zeroed
          END MAP
          MAP
            INTEGER*2 code,length
            INTEGER*4 devdep
          END MAP
        END UNION
      END STRUCTURE

      RECORD /iosb/ iosb
      RECORD /itmlst/ submit_list(6)

      LOGICAL DELETE
      CHARACTER*48 aqueue
      CHARACTER*48 aform
      CHARACTER*7 dqueue
      INTEGER*2 lq,lf

* argument checking with Fortran 6.+ , valid for VAX and AXP
! Declare pointer to argument list
      POINTER (ARGLIST_P, ARGLIST_ENTRY)
      INTEGER*4 ARGLIST_ENTRY
      INTEGER IARG,MARG
      PARAMETER (MARG= 4)  !<-insert number of expected args here
      LOGICAL ARG_EXIST(MARG)
      INTEGER nitems

      DATA dqueue/'PSLASER'/
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      DELETE = .true.
  100 CONTINUE

! Get base address of argument list and skip over count
! Use SIZEOF to be somewhat architecture independent
      ARGLIST_P = IARGPTR()+SIZEOF(ARGLIST_P)
D     TYPE *, ' Number of args:',iargcount()
      DO iarg=1,marg
        arg_exist(iarg)=.FALSE.
        IF (iargcount().GE.iarg) THEN
! address nonzero? -> arg present
D         TYPE 2000 , iarg,arglist_entry
 2000     FORMAT(' arg ',i3,' address=',Z8)
          IF (ARGLIST_ENTRY.NE.0) arg_exist(iarg)=.TRUE.
! Get address of next argument position
          ARGLIST_P = ARGLIST_P + SIZEOF(ARGLIST_P)
        ENDIF
      ENDDO

      lq=0
      IF (arg_exist(2)) THEN
        call STR$analyze_sdesc(queue,lq,iarg)
        CALL STR$copy_r(aqueue,lq,queue)
        CALL STR$TRIM(aqueue,aqueue,lq)
      ENDIF
      IF (lq.LE.0) THEN
        aqueue=dqueue
        lq=LEN(dqueue)
      ENDIF
      CALL fill_itmlst(submit_list(1),SJC$_queue,
     &  %REF(aqueue),lq)

      CALL fill_itmlst(submit_list(2),SJC$_file_specification,
     &  %REF(filename),LEN(filename))
      nitems=2

      IF (arg_exist(3)) THEN
        call STR$analyze_sdesc(form,lf,iarg)
        CALL STR$copy_r(aform,lf,form)
        CALL STR$TRIM(aform,aform,lf)
        IF (lf.GT.0) THEN
          nitems=nitems+1
          CALL fill_itmlst(submit_list(nitems),SJC$_form_name,
     &      %REF(aform),lf)
        ENDIF
      ENDIF

      IF (arg_exist(4)) THEN
        nitems=nitems+1
        CALL fill_itmlst(submit_list(nitems),SJC$_entry_number_output,
     &    %REF(ENTRY),4)
      ENDIF

      IF (DELETE) THEN
        nitems=nitems+1
        CALL fill_itmlst(submit_list(nitems),SJC$_delete_file)
      ENDIF
      CALL fill_itmlst(submit_list(nitems+1),0)

      status=SYS$SNDJBCW(,%VAL(SJC$_ENTER_FILE),,
     &          submit_list,iosb,,)
      IF (status) status = iosb.sts
      PRINT_and_delete = status
      RETURN

      ENTRY PRINT_and_keep(filename,queue,form,entry)
      DELETE = .false.
      GOTO 100
      END
