!<title> process_scan: sacn processes, return name,node,id,image </title>
! Author: Joseph Huber

	Integer Function PROCESS_SCAN(
     &     ctx,id,node_in,user_in,node,user,name,image)

*  This routine does a VMS process scan. 
*  The context ctx must initially be 0, and keeps the context over calls
*  Scans can be restricted to a specified node and user via node_in,user_in
*  Return value: VMS system service return code of last call 
*                warning SS$_NOMOREPROC ('09A8'X) means "no more processes"
 
	Implicit NONE
	Integer*4 ctx   !context value, initially=0, updated
	Integer*4 id    !identification of process last scanned
	Character*(*) node_in   !node to restrict scan, maybe '*'
	Character*(*) user_in   !user name to restrict scan, maybe '*'
	Character*(*) node   !returns node where the process runs
	Character*(*) user   !returns user name
	Character*(*) name   !returns process name
	Character*(*) image  !returns image active


        Include '($SYSSRVNAM)'
        INCLUDE '(LIB$ROUTINES)'
        INCLUDE '($LIBDEF)'
	Include '($jpidef)'
	Include '($pscandef)'

      STRUCTURE /itmlst/
        UNION
          MAP
            INTEGER*2 buflen,itmcod
            INTEGER*4 bufadr,retadr
          END MAP
          MAP
            INTEGER*4 end_list
          END MAP
        END UNION
      END STRUCTURE

	Integer status
	Integer*2 iosb(4),nnl,nnu,pnl,inl,snnl,sunl
	Record /itmlst/ pslist(3)	  
	Record /itmlst/ jpilist(6)	  

	character*32 nodename
	character*32 username

	If (ctx.EQ.0) Then
	 nodename = '*'
	 username = '*'
	 If (node_in .ne. ' ') nodename = node_in
	 If (user_in .ne. ' ') username = user_in
	 Call str$trim(nodename,nodename,snnl)
	 Call str$trim(username,username,sunl)
	 pslist(1).itmcod = pscan$_NODENAME
	 pslist(1).buflen = snnl
	 pslist(1).bufadr = %LOC(nodename)
	 pslist(1).retadr = pscan$M_WILDCARD 

	 pslist(2).itmcod = pscan$_USERNAME
	 pslist(2).buflen = sunl
	 pslist(2).bufadr = %LOC(username)
	 pslist(2).retadr = pscan$M_WILDCARD 
	 Call FILL_ITMLST(pslist(3),0)
	 process_scan = sys$process_scan(ctx,pslist)
	 if (.not.status) return
	EndIf

	node=' '
	user = ' '
	name = ' '
	image = ' '
	Call FILL_ITMLST(jpilist(1),JPI$_PID,id,4,)
	Call FILL_ITMLST(jpilist(2),
     &   JPI$_NODENAME,%REF(node),LEN(node),nnl)
	Call FILL_ITMLST(jpilist(3),
     &   JPI$_USERNAME,%REF(user),LEN(user),nnu)
	Call FILL_ITMLST(jpilist(4),
     &   JPI$_PRCNAM,%REF(name),LEN(name),pnl)
	Call FILL_ITMLST(jpilist(5),
     &   JPI$_IMAGNAME,%REF(image),LEN(image),inl)
	Call FILL_ITMLST(jpilist(6),0)
	status = sys$getjpiw(%VAL(0),
     &    ctx,%VAL(0),jpilist,iosb,%VAL(0),%VAL(0))

	process_scan = status
	if (status .AND. .NOT. iosb(1)) process_scan = iosb(1)
	End
