      INTEGER FUNCTION SEND_BROADCAST(user,message,reqid)
C
C-----------------------------------------
C
C   Author   :- J.Huber                3-JUN-1992
C
C=========================================
C
C   Purpose   : <title> broadcast a message to a user </title>
C   Returned value  : system service condition code
C   Inputs    :
C       character*(*) user    : username(s) to address
C       character*(*) message : the text to broadcast
C    optional integer reqid: reqid of sys$brkthru , default:BRK$C_GENERAL
C   Outputs   :
C
C Note: the user must have BROADCAST class of reqid enabled
C       (SET BROADCAST=reqid [GENERAL] if not =ALL)
C       Sender must have OPER or WORLD privilege if user != myself
C       Pseudo user "ALL": send to all logged in users.
C Example:
C       status = SEND_BROADCAST('DAQ','LAMONI - Channelmap out of order')
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      CHARACTER*(*) user,message
      INTEGER reqid
      INCLUDE '($SSDEF)/NOLIST'
      INCLUDE '($LIBDEF)/NOLIST'
      INCLUDE '($BRKDEF)/NOLIST'
      INCLUDE '(STR$ROUTINES)/NOLIST'
      INTEGER SYS$BRKTHRUW
      CHARACTER*32 suser
      integer*2 nc
      integer*2 iosb(4)
      integer I,code,N,reqidu,sendtyp

! Declare pointer to argument list
      POINTER (ARGLIST_P, ARGLIST_ENTRY)
      INTEGER*4 ARGLIST_ENTRY
! Declare pointer to individual argument
      POINTER (VALUE_P, VALUE)
      INTEGER*2 VALUE
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      reqidu=BRK$C_GENERAL !default broadcast class
      IF (iargcount().GT.2) THEN
! Get base address of argument list and skip over count
! Use SIZEOF to be somewhat architecture independent
       ARGLIST_P = IARGPTR()+SIZEOF(ARGLIST_P)
       DO I = 1, IARGCOUNT()
        VALUE_P = ARGLIST_ENTRY ! Get address of argument
        IF (I.EQ.3 .AND. VALUE_P.NE.0) reqidu = reqid
! Get address of next argument position
        ARGLIST_P = ARGLIST_P + SIZEOF(ARGLIST_P)
       END DO
      ENDIF
            
      send_broadcast=1

      N=0
      DO WHILE (.TRUE.)
      suser=' '
      code = STR$ELEMENT(suser,N,',',user)
      call STR$UPCASE(suser,suser)
      call STR$TRIM(suser,suser,nc)
      IF (nc.LE.0)        Return
D     print *,' sending to ',suser
       sendtyp=BRK$C_USERNAME
       IF (suser.eq.'ALL') THEN
        sendtyp=BRK$C_ALLUSERS
       ENDIF
       SEND_Broadcast = SYS$BRKTHRUW(,message,suser(1:nc),
     &        %VAL(sendtyp),iosb,%VAL(32),%VAL(BRK$M_CLUSTER),
     &        %VAL(reqidu),%VAL(10),,)
      N=N+1
      ENDDO
      END
