C#######################################################################
      INTEGER FUNCTION send_mail(user_name,file_name)
C----------------------------------------------------------------------
C
C   Purpose and Methods :
C <title> sends a mail using callable mail - example </title>
C
C   Created  1991   RSCS (J.Huber)
C
C This routine was written for our RSCS server to forward mail files 
C received from RSCS (Bitnet) to VMS destinations.
C It serves as an example for callable mail.
C From/date/subject info is assumed to be in the mail file.
C
C----------------------------------------------------------------------
      IMPLICIT NONE
C----------------------------------------------------------------------
c
C System service definitions
      INCLUDE '($SSDEF)'
      INCLUDE '($LIBDEF)'
      INCLUDE '($STRDEF)'
      INCLUDE '(LIB$ROUTINES)'
      INCLUDE '(STR$ROUTINES)'
      INCLUDE '($SYSSRVNAM)'
      INCLUDE '($maildef)/nolist'
      STRUCTURE /mail_item_array/
        INTEGER*2 len
        INTEGER*2 item_code
        INTEGER*4 address
        INTEGER*4 ret_len_addr
      END STRUCTURE
      INTEGER mail$send_begin,mail$send_add_attribute
      INTEGER mail$send_add_bodypart
      INTEGER mail$send_add_address
      INTEGER mail$send_message

      CHARACTER*(*) user_name,file_name
      RECORD /mail_item_array/ mess_info(4),null,body(3),address(3)
      INTEGER CONTEXT
      CHARACTER*255 from_line
      CHARACTER*255 subject
      CHARACTER*255 line
      CHARACTER*16 postmaster
      LOGICAL from_found,subj_found,cont_from,cont_subj
      INTEGER*2 ls2
      INTEGER ls,slen,Code

      send_mail = 0
*       defaults
      from_found=.false.
      subj_found=.false.
      from_line = 'RSCS'
      IF (user_name .EQ. ' ') THEN
        user_name = 'POSTMASTER'
        subject = 'Undelivered mail from RSCS Gateway'
      ELSE
        subject = 'Mail from RSCS% gateway delivery'
      ENDIF
*       open the file to read the "From:" and "Subject:" lines
      OPEN(unit=2,file=file_name,status='OLD',READONLY)
      DO WHILE(.NOT.(from_found.AND.subj_found))
        READ(2,'(A)',end=290,err=290) line
        CALL str$trim(line,line,ls)
        IF (line(1:1).EQ.' ') THEN      !continuation line ?
          IF (cont_from) THEN
            CALL str$trim(from_line,from_line,ls2)
            from_line(ls2+1:) = line
          ELSEIF (cont_subj) THEN
            CALL str$trim(subject,subject,ls2)
            subject(ls2+1:) = line
          ENDIF
        ELSEIF (STR$case_blind_compare(line(1:5),'From:').EQ.0) THEN
          from_line = line
          from_found=.true.
          cont_from = .true.
          cont_subj = .false.
        ELSEIF (STR$case_blind_compare(line(1:4),'Subj').EQ.0) THEN
          subject = line
          subj_found=.true.
          cont_from = .false.
          cont_subj = .true.
        ENDIF
      ENDDO
  290 CONTINUE
      CLOSE(UNIT=2)
* format from line for VMS mail
      CALL str$trim(from_line,from_line,ls2)
      CALL STR$right(from_line,from_line,6) !remove From: prefix
      ls=STR$find_first_in_set(from_line,'<')
      IF (ls.GT.0) THEN
        CALL STR$right(from_line,from_line,ls+1)
      ENDIF
      ls=STR$find_first_in_set(from_line,'>')
      IF (ls.GT.0) THEN
        CALL STR$left(from_line,from_line,ls-1)
      ENDIF
      ls=STR$find_first_not_in_set(from_line,' ')
      IF (ls.GT.1) THEN
        CALL STR$right(from_line,from_line,ls)
      ENDIF
      CALL STR$trim(from_line,from_line,ls2)
      from_line='RSCS%"'//from_line(1:ls2)//'"'
* format subject line for VMS mail
      CALL str$trim(subject,subject,ls2)
      ls=STR$find_first_in_set(subject,':')
      IF (ls.GT.0) THEN
        CALL STR$right(subject,subject,ls+1)
      ENDIF
      ls=STR$find_first_not_in_set(subject,' ')
      IF (ls.GT.1) THEN
        CALL STR$right(subject,subject,ls)
      ENDIF
      subject=subject

* if destination = postmaster, look if it's redirected by a logical
      IF (user_name(1:8) .EQ. 'POSTMAST') THEN
        slen = 0
        IF (LIB$sys_trnlog('POSTMASTER',slen,postmaster,,,0)) THEN
          user_name = postmaster
        ENDIF
      ENDIF
c changing the "From:" field requires SYSPRV
c If you do not have this priv, the item is ignored
      CALL setup_mail(mess_info(1),MAIL$_NOSIGNAL,NULL,)
      CALL setup_mail(mess_info(2),MAIL$_SEND_FROM_LINE,from_line,)
      CALL setup_mail(mess_info(3),MAIL$_SEND_SUBJECT,subject,)
      CALL setup_mail(address(1),MAIL$_NOSIGNAL,NULL,)
      CALL setup_mail(address(2),MAIL$_SEND_username,user_name,)
c the file is sent as the text of the message
      CALL setup_mail(body(1),MAIL$_NOSIGNAL,NULL,)
      CALL setup_mail(body(2),MAIL$_SEND_FILENAME,file_name,)
c
      code= mail$send_begin(CONTEXT, null, NULL)
	if (code) then
      code= mail$send_add_attribute(CONTEXT, mess_info, NULL)
	if (code) then
      code= MAIL$SEND_ADD_bodypart(CONTEXT, body, NULL)
	if (code) then
      code= MAIL$SEND_ADD_ADDRESS(CONTEXT, address, NULL)
	if (code) then
      code = mail$send_message(CONTEXT, NULL, NULL)
	endif
	endif
	endif
	endif

      call mail$send_end(CONTEXT, NULL, NULL)
	send_mail=code
      END


      SUBROUTINE setup_mail(item,code,string,ret_len)
      IMPLICIT NONE
      CHARACTER*(*) string
      INTEGER ret_len
      INTEGER code
      STRUCTURE /mail_item/
        INTEGER*2 len
        INTEGER*2 item_code
        INTEGER*4 address
        INTEGER*4 ret_len_addr
      END STRUCTURE

      RECORD /mail_item/ item
      CALL str$trim(string,string,item.len)
!      item.len=len(string)
      item.address=%loc(string)
      item.item_code=code
      item.ret_len_addr=%loc(ret_len)
      RETURN
      END
