      INTEGER FUNCTION SEND_MBX_MESSAGE(mbx_name,nb,buffer)
C
C-----------------------------------------
C
C   Author   :- J.Huber                23-May-1992
C
C=========================================
C
C   Purpose   :<title> General non-blocking write into a mailbox </title>
C
C   Returned value  : VMS system service code
C   Inputs    : character*(*) mbx_name: mailbox device name (may be logical)
C               integer*2 nb:           number of bytes to send
C               byte buffer(nb):        data to send
C   Outputs   :
C
C   Caveat Fortran programmers!
C      the buffer argument is an array, not a character string!
C      if a message defined as a character string is to be sent,
C      make a call by reference, example:
C      status send_mbx_message('MONITOR$SHUFFLER_MX:',20,%REF('BEGIN RUN'))
C
C=========================================
C +
C Declarations.
C -
      IMPLICIT NONE
      CHARACTER*(*) MBX_NAME
      INTEGER*2 NB
      BYTE BUFFER(NB)

      INCLUDE '($syssrvnam)'
      INCLUDE '($ssdef)'
      INCLUDE '($iodef)'

      INTEGER code
      INTEGER*2 MBXCHN
      INTEGER*2 iosb(4)
C + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
C Entry Point.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
* assign a channel to the SDSC$server_mbx
      code = sys$assign(MBX_NAME,mbxchn,,)
      IF (code) THEN
* send the message, nowait
        code = sys$qiow(,%VAL(mbxchn),
     &   %VAL(IO$_WRITEVBLK.OR.IO$M_NOW.OR.IO$M_NORSWAIT),iosb,,,
     &   %REF(BUFFER),%VAL(NB),%VAL(0),,,)
        IF (code) code = iosb(1)
      ENDIF
      CALL sys$dassgn(%VAL(mbxchn))
      SEND_MBX_MESSAGE = CODE
      END
