/*
   unsigned long int spawn_nowait(char* command,[char* input],[char* output]);

  This is 
<html><head><META name="keywords" content="VMS,spawn">
  <title>  C language interface to the VMS LIB$SPAWN run-time function </title></head><body><pre>
  it creates a subprocess executing the DCL command string in string command.
  The arguments in square brackets are optional, and may specify input- or
  output files or devices. If omitted (NULL), they are replaced by "NL:"
  The SPAWN flag CLI$M_NOWAIT is used, i.e. the command executes asynchroneous,
  the calling program does not wait (and does not get a subprocess status code
  back).
  
  The function return value is the VMS system service code of the SPAWN service 
  itself, NOT the exit code of the subprocess!

  Calling examples:
  
  code = spawn_nowait("@TEST.COM",NULL,NULL);  /*silent execution
  if (code&1 != 1) printf("error %d in spawn_nowait\n",code);

  code = spawn_nowait("@TEST.COM",NULL,"TEST.LOG"); /*output in file test.log

   Author: J.Huber   4-Apr-1994
*/  
#include descrip
#include stdio
#include libdef
#include lib$routines
#include clidef
#include string
unsigned long int spawn_nowait(command,input,output)
   char* command; 
   char* input;
   char* output;
 {
int flags = CLI$M_NOWAIT;
unsigned long int cond;
struct dsc$descriptor_s nl = { 
sizeof("NL:")-1, DSC$K_DTYPE_T, DSC$K_CLASS_S, "NL:" };

struct dsc$descriptor_s cdsc = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
struct dsc$descriptor_s idsc = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
struct dsc$descriptor_s odsc = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
struct dsc$descriptor_s* idsc_p;
struct dsc$descriptor_s* odsc_p;

cdsc.dsc$w_length = strlen(command);
cdsc.dsc$a_pointer = command;
odsc_p = &nl;
idsc_p = &nl;

if (input != NULL) 
     {idsc_p = &idsc;
      idsc.dsc$w_length=strlen(input);
      idsc.dsc$a_pointer=input;}

if (output != NULL) 
     {odsc_p = &odsc;
      odsc.dsc$w_length=strlen(output);
      odsc.dsc$a_pointer=output;}

#ifdef TEST
cond=lib$put_output(idsc_p);
cond=lib$put_output(odsc_p);
cond=lib$put_output(&cdsc);
#endif
cond = lib$spawn(&cdsc,idsc_p,odsc_p,&flags);
return(cond);
}
/*</pre></body></html>*/
