/* define the stream_f package functions */
#ifndef __STREAM_F_DEFINED__
#define __STREAM_F_DEFINED__
#ifdef __VMS
#include <descrip.h>
#endif

void stream_finit() ;
#if defined (__vms)
void stream_finit_vms() ;
#endif

int stream_fclose(int *fid);

/* stream_fopen : returns nonzero=success=fid, 0 = error */
/* mode string:  C    Shortly, it consists of up to 3 letters:

    1. r/w/a   for read/write/append
    2. +       update access (should be avoided for this package)
    3. b       binary : no conversion of carriage control (recommended)
Fortran call: code = stream_fopen( fid , 'myfile.dat', 'rb')
    The output argument fid should be saved over all calls to this package
    (stream_fread,_fwrite,_fclose). It serves as a context variable to
    identify the open stream, so Several streams may be open and used in the
    same program unit.
*/
 
#if defined (__vms)
int stream_fopen(int *fid,struct dsc$descriptor_s *file_name,
		   struct dsc$descriptor_s *mode);
#else
int stream_fopen(int *fid,char *file_name,char *mode);
#endif

/* stream_fread returns  the number of bytes read */
/* length is number of bytes  */
int stream_fread(int *fid,void *buffer,int *length);

/* stream_fwrite returns the number of bytes written */
/* length is number of bytes  */
int stream_fwrite(int *fid,void *buffer,int *length);


/* stream_fseek: set file position
   offset: integer bytes to move position
   direction:from were to start positiong
   See help cc run-time fseek for the direction values
   Default for direction=0 is SEEKSET, i.e. offset is from begin of file
   The current definition in DECC is
      #define SEEK_SET 0
      #define SEEK_CUR 1
      #define SEEK_END 2
*/
int stream_fseek(int *fid, int *offset, int *direction);
#endif


/* vms.mppmu.mpg.de cluster:
 source: disk$huber:[huber.util]stream_f.c
 header: util_root:[include]stream_f.h (#include <stream_f.h> and CC/INCLUDE=util_root:[include])
         util_root:[include]stream_f.inc (include 'stream_f.h' and FORTRAN/INCLUDE=util_root:[include])
 link library: sys$library:util.olb
*/

