C define the stream_f package functions 

C CALL STREAM_FINIT once at program start
C CALL_STREAM_FINIT_VMS instead if no other call to DECC$CRTL_INIT in the program.
	EXTERNAL STREAM_FINIT
	EXTERNAL STREAM_FINIT_VMS

C Fortran call: code = stream_fopen( fid , 'myfile.dat', 'rb')
C stream_fopen : returns nonzero=fid=success, 0=error 
C mode string:  C    Shortly, it consists of up to 3 letters:
C    1. r/w/a   for read/write/append
C    2. +       update access (should be avoided for this package)
C    3. b       binary : no conversion of carriage control (recommended)
C    The output argument fid should be saved over all calls to this package
C    (stream_fread,_fwrite,_fclose). It serves as a context variable to
C    identify the open stream, so Several streams may be open and used in the
C    same program unit.
	INTEGER STREAM_FOPEN
	EXTERNAL STREAM_FOPEN

C Fortran call: code = stream_fclose( fid )
	INTEGER STREAM_FCLOSE
	EXTERNAL STREAM_FCLOSE

C stream_fread returns  the number of bytes read 
C length is number of bytes  
C	nb = stream_fread(fid,buffer,length
	INTEGER STREAM_FREAD
	EXTERNAL STREAM_FREAD

C stream_fwrite returns the number of bytes written 
C length is number of bytes  
C  nw = stream_fwrite(fid,buffer,length)
	INTEGER STREAM_FWRITE
	EXTERNAL STREAM_FWRITE


C stream_fseek: set file position
C   offset: integer bytes to move position
C   direction:from were to start positiong
C   See help cc run-time fseek for the direction values
C   Default for direction=0 is SEEKSET, i.e. offset is from begin of file
C   The current definition in DECC is
C      #define SEEK_SET 0
C      #define SEEK_CUR 1
C      #define SEEK_END 2

C code = stream_fseek(fid, offset, direction);
	INTEGER STREAM_FSEEK
	EXTERNAL STREAM_FSEEK


C vms.mppmu.mpg.de cluster:
C source: disk$huber:[huber.util]stream_f.c
C header: util_root:[include]stream_f.h (#include <stream_f.h> and CC/INCLUDE=UTIL_ROOT:[INCLUDE])
C         util_root:[include]stream_f.inc ( include 'stream_f.inc'and FORTRAN/INCLUDE=UTIL_ROOT:[INCLUDE] )
C link library: sys$library:util.olb

