*<title>Fortran Example of IARGCOUNT, IARGPTR and POINTER</title>
C from Fortran 6.1 release notes
c             Example 2-2 demonstrates the use of the IARGCOUNT and
c              IARGPTR intrinsics as well as of the POINTER statement:
c              Example 2-2 Example of IARGCOUNT, IARGPTR and POINTER

      PROGRAM ARGLIST_TEST
      INTEGER*4 X,Y,Z
      X = 10
      Y = 20
      Z = 100
!      PRINT 800, %LOC(X), %LOC(Y), %LOC(Z)
      PRINT 800, %LOC(X), 0, %LOC(Z)
  800 FORMAT (' Argument addresses: ',3(1x, Z8.8))
      CALL ARGLIST_SUB (X, , Z)
      END

      SUBROUTINE ARGLIST_SUB
! Declare pointer to argument list
      POINTER (ARGLIST_P, ARGLIST_ENTRY)
      INTEGER*4 ARGLIST_ENTRY
! Declare pointer to individual argument
      POINTER (VALUE_P, VALUE)
      INTEGER VALUE

! Get base address of argument list and skip over count
! Use SIZEOF to be somewhat architecture independent
!
      ARGLIST_P = IARGPTR()+SIZEOF(ARGLIST_P)


! Display count of arguments and then, for each argument
! passed, display its value.
!
      PRINT *,'Called with ',IARGCOUNT(), ' arguments'
      DO I = 1, IARGCOUNT()
        VALUE_P = ARGLIST_ENTRY ! Get address of argument
!        PRINT 900, I, VALUE_P, VALUE
        PRINT 900, I, VALUE_P
  900   FORMAT ( ' Argument ', I2, ' address = ', Z8.8)
!     &           ', contents = ', I5)
! Get address of next argument position
        ARGLIST_P = ARGLIST_P + SIZEOF(ARGLIST_P)
      END DO
      RETURN
      END
