	PROGRAM MTTEST
C+
C<title>Simple TEST FOR MTUTIL package</title>
c	Reads 1-character commands from SYS$INPUT
c	to call routines of the MTutil packet
c	and to print I/O status results
c	    typical I/O status codes (first halfword):
c	1 = normal (SS$_normal)
c	840 = device allocated
c	9A0 = EOV SS$_endofvolume
c	870 = EOF SS$_endoffile
c	878 = EOT SS$_endoftape
c
c	Commands:
c	Ax = Assign tape drive and position tape 
c	 where x = S :'stay' don't change position
c	           R : rewind tape
c	           N : position past EOV to write new file
c	           A : position at end of last file for append
c
c	C: 'close file' writes EOV at current position
c	F: space over tapemarks (number will be asked from terminal)
c	B: space over blocks (number will be asked from terminal)
c	R: read a block 
c	W: write a block (a 4KByte block will be written)
c	S: sense characteristics (2'nd IOSB word return tape characteristics)
c       T: read until EOF, display record length
c	U: rewind and unload tape
c	Z: rewind tape to BOT
c	Control+Z: exit program
c	
c	See the MT$ASSIGN call for the (logical) device name for the tape used
C-
	Parameter NCMD = 10
	Character CMD(NCMD)
	Character TTY(20)
	INTEGER BUF(8192),IDS,KK
	INTEGER*2 IST(2),IOSB(2),Chan
	equivalence (IOSB(1),IST(1))

	DATA CMD/'A','C','F','B','R','W','S','U','Z','T'/

6000	FORMAT(' A/C/F/B/R/W/S/U/Z/T'/,'$CMD>')
6001	FORMAT(' IDS ',Z8,' ISTAT',Z8,' ',Z8)
5000	FORMAT(20A1)
	

10	CONTINUE
	TYPE 6000 
	READ(5,5000,END=900) TTY
	DO 20 I=1,NCMD
	IF (CMD(I).EQ.TTY(1)) GO TO 30
20	CONTINUE	
	GO TO 10
30	GO TO (110,120,130,140,150,160,170,180,190,200) , I
	GO TO 10
110	CONTINUE	!ASSIGN DRIVE
c
c	$TAPE1 is the system-wide logical name for the tape drive
c	you may exchange this name also to a hardware name e.g. 'MSA0:'
c
	IDS = MT$ASSIGN('$TAPE',Chan,0,IST,TTY(2))

115	CONTINUE
	TYPE 6001 , IDS,IST
	GO TO 10

120	CONTINUE	!CLOSE WITH EOV
	IDS = MT$CLOSE(Chan,IOSB)
	GO TO 115
130	CONTINUE	!SPACE FILE
	Type *, '$Files to skip:'
	Accept *, KK
	IDS = MT$SPF(Chan,KK,IST)
	GO TO 115
140	CONTINUE	!SPACE BLOCKS
	Type *, '$Blocks to skip:'
	Accept *, KK
	IDS = MT$SPB(Chan,KK,IST)
	GO TO 115

150	CONTINUE	!READ BLOCK
	IDS = MT$READ(Chan,32764,BUF,IST)
	GO TO 115
160	CONTINUE	!WRITE BLOCK
	IDS = MT$WRITE(Chan,32764,BUF,IST)
	GO TO 115
170	CONTINUE	!S = Sense 
	IDS = MT$SENSE(Chan,IOSB)
	Go to 115
180	CONTINUE	!U = Unload
	IDS = MT$UNLOAD(Chan,IOSB,.TRUE.)
	Go to 115
190	CONTINUE	!Z = Rewind to BOT
	IDS = MT$Rewind(Chan,IOSB,.TRUE.)
	Go to 115

  200 continue
      ids = 1
      ir = 0
      do while (ids)
	IDS = MT$READ(Chan,32764,BUF,IOSB)
        type * , ' Read record',ir,' length=',iosb(2)
        ir = ir+1
        enddo
	Go to 115
900	STOP
	END
