/* time_to_tm
<title>  returns a given Unix binary time in an struct tm </title>  

*/

#include <time.h>
#include <string.h>
#ifdef __vms
#define _POSIX_SOURCE
#endif

  void time_to_tm ( const time_t bintim, struct tm * tmar) {


#if       defined( _POSIX_SOURCE )
    (void *) localtime_r( &bintim , tmar );
#else
    struct tm * ltm;
    ltm = localtime( &bintim );
    memmove ( tmar , ltm, sizeof( struct tm) );
#endif
}

#ifdef TEST
#include <stdio.h>

main() {

   struct tm tmar;
   time_t t = 1018430492 ;
   
   time_to_tm( t , &tmar);

   printf (" tmar returned contents:\n");
   printf(" sec %d",tmar.tm_sec);      /* seconds after the minute [0, 61]  */
   printf(" min %d",tmar.tm_min);      /* minutes after the hour [0, 59]    */
   printf(" h %d",tmar.tm_hour);     /* hours since midnight [0, 23]      */
   printf(" day %d",tmar.tm_mday);     /* day of the month [1, 31]          */
   printf(" month %d",tmar.tm_mon);      /* months since January [0, 11]      */
   printf(" year %d\n",tmar.tm_year);     /* years since 1900                  */
   printf(" weekday %d",tmar.tm_wday);     /* days since Sunday [0, 6]          */
   printf(" yday %d",tmar.tm_yday);     /* days since January 1 [0, 365]     */
   printf(" DST %d",tmar.tm_isdst);    /* Daylight Saving Time flag         */
   printf(" GMTOFF %d",tmar.tm_gmtoff);  /* offset from UTC in seconds        */
   printf(" Zone %s\n",tmar.tm_zone);   /* timezone abbreviation             */

   time_to_tm( time(0) , &tmar);


   printf (" tmar returned contents:\n");
   printf(" sec %d",tmar.tm_sec);      /* seconds after the minute [0, 61]  */
   printf(" min %d",tmar.tm_min);      /* minutes after the hour [0, 59]    */
   printf(" h %d",tmar.tm_hour);     /* hours since midnight [0, 23]      */
   printf(" day %d",tmar.tm_mday);     /* day of the month [1, 31]          */
   printf(" month %d",tmar.tm_mon);      /* months since January [0, 11]      */
   printf(" year %d\n",tmar.tm_year);     /* years since 1900                  */
   printf(" weekday %d",tmar.tm_wday);     /* days since Sunday [0, 6]          */
   printf(" yday %d",tmar.tm_yday);     /* days since January 1 [0, 365]     */
   printf(" DST %d",tmar.tm_isdst);    /* Daylight Saving Time flag         */
   printf(" GMTOFF %d",tmar.tm_gmtoff);  /* offset from UTC in seconds        */
   printf(" Zone %s\n",tmar.tm_zone);   /* timezone abbreviation             */


   }
#endif
